package com.landray.kmss.sys.attachment.service.spring;

import com.landray.kmss.sys.filestore.model.SysFileConvertQueue;
import com.landray.kmss.framework.plugin.core.config.IExtension;
import com.landray.kmss.framework.plugin.core.config.IExtensionPoint;
import com.landray.kmss.sys.filestore.queue.service.ConvertAddQueueExtension;
import com.landray.kmss.framework.service.plugin.Plugin;
import com.landray.kmss.sys.filestore.queue.dto.ConvertParameter;
import com.landray.kmss.util.HtmlToMht;
import com.landray.kmss.sys.filestore.util.SysFileStoreUtil;
import com.landray.kmss.sys.filestore.queue.dto.AddQueneParameter;
import org.apache.commons.io.FilenameUtils;
import java.util.Map;
import java.util.HashMap;
import com.landray.kmss.sys.filestore.location.interfaces.ISysFileLocationDirectService;
import java.net.URLEncoder;
import com.landray.kmss.sys.attachment.restservice.wps.util.WpsUtil;
import com.landray.kmss.sys.attachment.integrate.wps.util.SysAttWpsWebOfficeUtil;
import com.landray.kmss.sys.attachment.integrate.wps.util.FileDowloadUtil;
import com.landray.kmss.sys.config.loader.ConfigLocationsUtil;
import org.apache.commons.lang3.ArrayUtils;
import org.apache.commons.beanutils.PropertyUtils;
import com.landray.kmss.sys.attachment.util.SysAttViewerUtil;
import com.landray.kmss.sys.attachment.forms.SysAttMainForm;
import com.landray.kmss.sys.restservice.server.model.SysRestserviceServerMain;
import com.landray.kmss.sys.restservice.server.model.SysRestserviceServerPolicy;
import com.landray.kmss.sys.restservice.server.service.ISysRestserviceServerMainService;
import com.landray.kmss.sys.attachment.util.SysAttUtil;
import com.landray.kmss.sys.webservice2.model.SysWebserviceMain;
import com.landray.kmss.util.SignUtil;
import com.landray.kmss.sys.webservice2.model.SysWebserviceUser;
import com.landray.kmss.util.ArrayUtil;
import com.landray.kmss.sys.webservice2.service.ISysWebserviceMainService;
import com.landray.kmss.common.service.IBaseService;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.landray.kmss.sys.config.dict.SysDictModel;
import com.landray.kmss.sys.config.dict.SysDataDict;
import org.json.simple.JSONObject;
import net.sf.json.JSONArray;
import java.math.BigDecimal;
import com.landray.kmss.util.FileUtil;
import com.landray.kmss.sys.cluster.interfaces.message.IMessage;
import com.landray.kmss.sys.cluster.interfaces.MessageCenter;
import org.hibernate.query.NativeQuery;
import com.landray.kmss.util.ResourceUtil;
import java.util.Calendar;
import com.landray.kmss.sys.quartz.interfaces.SysQuartzJobContext;
import com.landray.kmss.sys.attachment.io.DecryptionInputStream;
import java.io.FileOutputStream;
import java.io.FileInputStream;
import com.landray.kmss.util.ServerUtil;
import com.landray.kmss.util.ModelUtil;
import com.landray.kmss.util.FileMimeTypeUtil;
import javax.servlet.http.HttpServletResponse;
import java.awt.image.BufferedImage;
import java.io.IOException;
import javax.imageio.ImageIO;
import javax.servlet.http.HttpServletRequest;
import com.landray.kmss.sys.attachment.io.IOUtil;
import com.sunbor.web.tag.Page;
import com.landray.kmss.sys.log.util.UserOperHelper;
import java.util.concurrent.ConcurrentHashMap;
import org.hibernate.query.Query;
import com.landray.kmss.sys.filestore.location.interfaces.ISysFileLocationProxyService;
import com.landray.kmss.sys.attachment.integrate.yozo.SysAttYozoUtil;
import com.landray.kmss.sys.attachment.ocx.SysAttOcxUtil;
import com.landray.kmss.sys.attachment.util.SysAttConfigUtil;
import com.landray.kmss.sys.attachment.integrate.wps.util.SysAttWpsCenterUtil;
import com.landray.kmss.sys.attachment.integrate.wps.util.SysAttWpsCloudUtil;
import java.io.File;
import java.sql.Blob;
import com.landray.kmss.sys.attachment.util.AttImageUtils;
import com.landray.kmss.sys.attachment.model.SysAttBase;
import com.landray.kmss.sys.filestore.location.util.SysFileLocationUtil;
import java.io.OutputStream;
import com.landray.kmss.sys.attachment.util.ImageCompressUtils;
import java.io.ByteArrayOutputStream;
import com.landray.kmss.sys.attachment.model.SysAttRtfData;
import com.landray.kmss.util.UserUtil;
import com.landray.kmss.util.IDGenerator;
import java.util.Iterator;
import com.landray.kmss.common.dao.HQLInfo;
import java.io.InputStream;
import java.io.ByteArrayInputStream;
import com.landray.kmss.util.MD5Util;
import org.apache.commons.io.IOUtils;
import com.landray.kmss.sys.attachment.model.SysAttMain;
import com.landray.kmss.common.model.IBaseModel;
import java.util.ArrayList;
import com.landray.kmss.sys.filestore.model.SysAttFile;
import org.hibernate.Session;
import java.util.Collection;
import com.landray.kmss.util.StringUtil;
import java.util.List;
import java.util.Date;
import com.landray.kmss.sys.attachment.dao.ISysAttMainCoreInnerDao;
import com.landray.kmss.util.SpringBeanUtil;
import com.landray.kmss.sys.cluster.interfaces.message.UniqueMessageQueue;
import org.slf4j.LoggerFactory;
import com.landray.kmss.sys.cluster.interfaces.message.IMessageQueue;
import com.landray.kmss.sys.cache.KmssCache;
import com.landray.kmss.sys.cache.CacheConfig;
import com.landray.kmss.sys.attachment.service.ISysAttDownloadLogService;
import com.landray.kmss.sys.filestore.service.ISysFileConvertQueueService;
import com.landray.kmss.sys.filestore.service.ISysAttUploadService;
import org.slf4j.Logger;
import com.landray.kmss.sys.cluster.interfaces.message.IMessageReceiver;
import com.landray.kmss.sys.attachment.service.ISysAttMainCoreInnerService;
import com.landray.kmss.common.service.BaseCoreInnerServiceImp;

public class SysAttMainCoreInnerServiceImp extends BaseCoreInnerServiceImp implements ISysAttMainCoreInnerService, IMessageReceiver
{
    public static final String IMG_COMPASS_SIGN_M = "m";
    public static final String IMG_COMPASS_SIGN_S = "s";
    private static final Logger logger;
    protected ISysAttUploadService sysAttUploadService;
    protected ISysFileConvertQueueService convertQueueService;
    protected ISysAttDownloadLogService sysAttDownloadLogService;
    private CacheConfig config;
    private KmssCache cache;
    protected boolean runnabled;
    protected IMessageQueue messageQueue;
    
    static {
        logger = LoggerFactory.getLogger(SysAttMainCoreInnerServiceImp.class);
    }
    
    public SysAttMainCoreInnerServiceImp() {
        this.config = null;
        this.cache = null;
        this.runnabled = true;
        this.messageQueue = (IMessageQueue)new UniqueMessageQueue();
        this.config = CacheConfig.get((Class)SysAttMainCoreInnerServiceImp.class);
        this.config.cacheType = 3;
        this.cache = new KmssCache((Class)SysAttMainCoreInnerServiceImp.class);
    }
    
    public ISysFileConvertQueueService getConvertQueueService() {
        if (this.convertQueueService == null) {
            this.convertQueueService = (ISysFileConvertQueueService)SpringBeanUtil.getBean("sysFileConvertQueueService");
        }
        return this.convertQueueService;
    }
    
    public void setSysAttUploadService(final ISysAttUploadService sysAttUploadService) {
        this.sysAttUploadService = sysAttUploadService;
    }
    
    public ISysAttMainCoreInnerDao getSysAttMainDao() {
        return (ISysAttMainCoreInnerDao)this.getBaseDao();
    }
    
    public void setSysAttDownloadLogService(final ISysAttDownloadLogService sysAttDownloadLogService) {
        this.sysAttDownloadLogService = sysAttDownloadLogService;
    }
    
    public Date getCurTimestamp() throws Exception {
        return this.sysAttUploadService.getCurTimestamp();
    }
    
    public List<String> getAttIds(final List<String> fdList, final String queryStr, final String modelName) throws Exception {
        final Session session = this.getBaseDao().getHibernateSession();
        List<String> fdIds = null;
        if (StringUtil.isNull(modelName)) {
            fdIds = session.createNativeQuery(queryStr).setParameterList("list", (Collection)fdList).list();
        }
        else {
            fdIds = session.createNativeQuery(queryStr).setParameterList("fileIds", (Collection)fdList).setParameter("modelName", (Object)modelName).list();
        }
        return fdIds;
    }
    
    public List<SysAttFile> findNotExistMainBeforeByTime(final int limitNum) throws Exception {
        return this.sysAttUploadService.findNotExistMainBeforeByTime(limitNum);
    }
    
    public List add(final List sysAttMains) throws Exception {
        final List<IBaseModel> result = new ArrayList<IBaseModel>();
        for (final SysAttMain sysAttMain : sysAttMains) {
            if ("fdAttachmentPic".equals(sysAttMain.getFdKey())) {
                final byte[] inputSreamByt = IOUtils.toByteArray(sysAttMain.getInputStream());
                final String fileMd5 = MD5Util.getMD5String(inputSreamByt);
                final SysAttFile attfile = this.sysAttUploadService.getFileByMd5(fileMd5, sysAttMain.getFdSize().longValue());
                sysAttMain.setInputStream((InputStream)new ByteArrayInputStream(inputSreamByt));
                if (attfile != null) {
                    final HQLInfo hql = new HQLInfo();
                    hql.setWhereBlock("sysAttMain.fdFileId=:fdFileId");
                    hql.setParameter("fdFileId", (Object)attfile.getFdId());
                    final Object obj = this.getSysAttMainDao().findFirstOne(hql);
                    if (obj != null) {
                        result.add((IBaseModel)obj);
                    }
                    else {
                        this.add((IBaseModel)sysAttMain);
                        result.add((IBaseModel)sysAttMain);
                    }
                }
                else {
                    this.add((IBaseModel)sysAttMain);
                    result.add((IBaseModel)sysAttMain);
                }
            }
            else {
                this.add((IBaseModel)sysAttMain);
                result.add((IBaseModel)sysAttMain);
            }
        }
        return result;
    }
    
    public String add(final IBaseModel modelObj) throws Exception {
        return this.add(modelObj, false);
    }
    
    public String add(final IBaseModel modelObj, final Boolean newFieldId) throws Exception {
        return this.add(modelObj, newFieldId, true);
    }
    
    public String add(final IBaseModel modelObj, final Boolean newFieldId, final Boolean addQueue) throws Exception {
        final SysAttMain sysAttMain = (SysAttMain)modelObj;
        String fileId = sysAttMain.getFdFileId();
        if (sysAttMain.getFdVersion() == null || sysAttMain.getFdVersion() == 0) {
            sysAttMain.setFdVersion(Integer.valueOf(1));
        }
        if (sysAttMain.getFdUploadTime() == null) {
            sysAttMain.setFdUploadTime(sysAttMain.getDocCreateTime());
        }
        if (newFieldId) {
            final String md5 = MD5Util.getMD5String(IDGenerator.generateID());
            fileId = this.sysAttUploadService.addFile(md5, 0L, sysAttMain.getInputStream(), true, sysAttMain.getFdFileName());
            sysAttMain.setFdFileId(fileId);
            sysAttMain.setInputStream((InputStream)null);
            if (SysAttMainCoreInnerServiceImp.logger.isDebugEnabled()) {
                SysAttMainCoreInnerServiceImp.logger.debug("增加附件信息：文件流随附件信息一起传递情况。");
            }
        }
        else if (StringUtil.isNotNull(fileId)) {
            if (sysAttMain.getFdSize() == null || sysAttMain.getFdSize() == 0.0) {
                final SysAttFile attFile = this.sysAttUploadService.getFileById(fileId);
                sysAttMain.setFdSize(Double.valueOf((double)attFile.getFdFileSize()));
            }
            if (SysAttMainCoreInnerServiceImp.logger.isDebugEnabled()) {
                SysAttMainCoreInnerServiceImp.logger.debug("增加附件信息：上传文件后，再增加附件信息情况。");
            }
        }
        else {
            fileId = this.sysAttUploadService.addFile(sysAttMain.getInputStream(), sysAttMain.getFdFileName());
            sysAttMain.setFdFileId(fileId);
            sysAttMain.setInputStream((InputStream)null);
            if (SysAttMainCoreInnerServiceImp.logger.isDebugEnabled()) {
                SysAttMainCoreInnerServiceImp.logger.debug("增加附件信息：文件流随附件信息一起传递情况。");
            }
        }
        if (StringUtil.isNull(sysAttMain.getFdCreatorId())) {
            sysAttMain.setFdCreatorId(UserUtil.getUser().getFdId());
        }
        if (StringUtil.isNull(sysAttMain.getFdUploaderId())) {
            sysAttMain.setFdUploaderId(sysAttMain.getFdCreatorId());
        }
        if (sysAttMain.getAddQueue() && addQueue) {
            this.getConvertQueueService().addQueueAndPdfUpdate(sysAttMain, sysAttMain, sysAttMain.getFdFileId(), sysAttMain.getFdFileName(), sysAttMain.getFdModelName(), sysAttMain.getFdModelId(), "", sysAttMain.getFdId());
            this.getConvertQueueService().addFileToQueue(sysAttMain, sysAttMain);
        }
        return this.getSysAttMainDao().add((IBaseModel)sysAttMain);
    }
    
    private void addComprassFile(final SysAttRtfData sysAttRtfData, final SysAttFile attFile, final String suffix) throws Exception {
        if (SysAttMainCoreInnerServiceImp.logger.isDebugEnabled()) {
            SysAttMainCoreInnerServiceImp.logger.debug("addFile_上传整个文件，不切片。。");
        }
        final String path = String.valueOf(this.sysAttUploadService.getAbsouluteFilePath(attFile)) + "_" + suffix;
        ByteArrayOutputStream output = null;
        try {
            output = new ByteArrayOutputStream();
            ImageCompressUtils.getInstance().compressImage(sysAttRtfData.getInputStream(), (OutputStream)output, (int)sysAttRtfData.getWidth(), (int)sysAttRtfData.getHeight(), true);
            SysFileLocationUtil.getProxyService(attFile.getFdAttLocation()).writeFile(output.toByteArray(), path);
        }
        catch (final Throwable t) {
            try {
                output.close();
            }
            catch (final Exception ex) {}
        }
        finally {
            try {
                output.close();
            }
            catch (final Exception ex2) {}
        }
        try {
            output.close();
        }
        catch (final Exception ex3) {}
    }
    
    private void proccessPic(final SysAttMain sysAttMain) throws Exception {
        if ("pic".equals(sysAttMain.getFdAttType()) && sysAttMain.getWidth() > 0 && sysAttMain.getHeight() > 0) {
            if (SysAttMainCoreInnerServiceImp.logger.isDebugEnabled()) {
                SysAttMainCoreInnerServiceImp.logger.debug("保存一份未压缩的原始图片附件。");
            }
            byte[] imagesByte = null;
            if (sysAttMain.getInputStream() != null) {
                imagesByte = IOUtils.toByteArray(sysAttMain.getInputStream());
            }
            else {
                imagesByte = IOUtils.toByteArray(this.getIntputStream((SysAttBase)sysAttMain, false));
            }
            final ByteArrayInputStream byteIn = new ByteArrayInputStream(imagesByte);
            final SysAttMain original = (SysAttMain)sysAttMain.clone();
            original.setFdKey("original");
            original.setFdModelName(SysAttMain.class.getName());
            original.setFdModelId(sysAttMain.getFdId());
            original.setFdFileId(sysAttMain.getFdFileId());
            this.getSysAttMainDao().add((IBaseModel)original);
            sysAttMain.setInputStream((InputStream)byteIn);
            if (sysAttMain.getInputStream() != null) {
                if (sysAttMain.getInputStream().markSupported()) {
                    sysAttMain.getInputStream().reset();
                }
                AttImageUtils.resetInputStream((SysAttBase)sysAttMain);
                sysAttMain.setFdFileId(this.sysAttUploadService.addFile(sysAttMain.getInputStream(), sysAttMain.getFdFileName()));
            }
            sysAttMain.setFdModelId((String)null);
        }
    }
    
    public void updateByUser(final IBaseModel modelObj, final String userId) throws Exception {
        final SysAttMain sysAttMain = (SysAttMain)modelObj;
        final SysAttMain oldSysAttMain = (SysAttMain)sysAttMain.clone();
        if (sysAttMain.getInputStream() != null) {
            if (SysAttMainCoreInnerServiceImp.logger.isDebugEnabled()) {
                SysAttMainCoreInnerServiceImp.logger.debug("编辑附件处理：存在附件流的情况。");
            }
            AttImageUtils.resetInputStream((SysAttBase)modelObj);
            final String returnString = this.sysAttUploadService.updateFile(sysAttMain.getFdId(), sysAttMain.getFdFileId(), sysAttMain.getInputStream());
            if (StringUtil.isNotNull(returnString)) {
                final String fileId = returnString.split(";")[0];
                final String fileSize = returnString.split(";")[1];
                sysAttMain.setFdFileId(fileId);
                sysAttMain.setFdSize(Double.valueOf(fileSize));
            }
            if (StringUtil.isNull(sysAttMain.getFdFileId())) {
                sysAttMain.setFdData((Blob)null);
                if (StringUtil.isNotNull(sysAttMain.getFdFilePath())) {
                    final File oldFile = new File(sysAttMain.getFdFilePath());
                    if (oldFile.exists()) {
                        oldFile.delete();
                    }
                    sysAttMain.setFdFilePath((String)null);
                }
            }
            sysAttMain.setInputStream((InputStream)null);
            if (StringUtil.isNull(oldSysAttMain.getFdUploaderId())) {
                oldSysAttMain.setFdUploaderId(oldSysAttMain.getFdCreatorId());
            }
            if (StringUtil.isNotNull(userId)) {
                sysAttMain.setFdUploaderId(userId);
            }
            else {
                sysAttMain.setFdUploaderId(UserUtil.getKMSSUser().getPerson().getFdId());
            }
            Boolean isNewVersion = false;
            if (!sysAttMain.getFdUploaderId().equals(oldSysAttMain.getFdUploaderId()) || UserUtil.getKMSSUser().isAnonymous()) {
                isNewVersion = true;
            }
            if (SysAttWpsCloudUtil.isEnable() && sysAttMain.getFdUploaderId().equals(oldSysAttMain.getFdUploaderId()) && UserUtil.getKMSSUser().isAnonymous()) {
                isNewVersion = false;
            }
            if ((SysAttWpsCenterUtil.isEnable() || SysAttConfigUtil.isWpsCenterV6Enabled()) && UserUtil.getKMSSUser().isAnonymous() && sysAttMain.getFdUploaderId().equals(oldSysAttMain.getFdUploaderId())) {
                isNewVersion = false;
            }
            sysAttMain.setInputStream((InputStream)null);
            if ((("0".equals(SysAttConfigUtil.getOnlineToolType()) && "2".equals(SysAttConfigUtil.isReadJGForMobile())) || ("3".equals(SysAttConfigUtil.getOnlineToolType()) && "2".equals(SysAttConfigUtil.isReadWPSForMobile()))) && UserUtil.getKMSSUser().isAnonymous()) {
                isNewVersion = false;
            }
            final String ocxName = SysAttOcxUtil.getDocOcxName(sysAttMain.getFdKey(), sysAttMain.getFdModelName());
            if (StringUtil.isNotNull(ocxName)) {
                if ("03".equals(ocxName) && sysAttMain.getFdUploaderId().equals(oldSysAttMain.getFdUploaderId()) && UserUtil.getKMSSUser().isAnonymous()) {
                    isNewVersion = false;
                }
                else if ("07".equals(ocxName) && sysAttMain.getFdUploaderId().equals(oldSysAttMain.getFdUploaderId()) && UserUtil.getKMSSUser().isAnonymous()) {
                    isNewVersion = false;
                }
                else if (("02".equals(ocxName) || "06".equals(ocxName)) && UserUtil.getKMSSUser().isAnonymous()) {
                    isNewVersion = false;
                }
            }
            if (sysAttMain.getFdVersion() == null || sysAttMain.getFdVersion() == 0) {
                oldSysAttMain.setFdVersion(Integer.valueOf(1));
                sysAttMain.setFdVersion(Integer.valueOf(2));
            }
            else if (isNewVersion) {
                oldSysAttMain.setFdVersion(sysAttMain.getFdVersion());
                sysAttMain.setFdVersion(Integer.valueOf(sysAttMain.getFdVersion() + 1));
            }
            sysAttMain.setFdUploadTime(new Date());
            if (oldSysAttMain.getFdUploadTime() == null) {
                oldSysAttMain.setFdUploadTime(oldSysAttMain.getDocCreateTime());
            }
            this.getSysAttMainDao().update(modelObj);
            oldSysAttMain.setFdKey("historyVersionAttachment");
            if ((SysAttWpsCenterUtil.isEnable() || SysAttConfigUtil.isWpsCenterV6Enabled()) && !isNewVersion) {
                isNewVersion = true;
                oldSysAttMain.setFdKey("WPSCenterSelfAttachment");
                oldSysAttMain.setFdVersion(Integer.valueOf(0));
            }
            if (SysAttYozoUtil.isEnable()) {
                oldSysAttMain.setFdKey("YozoHistoryAttachment");
            }
            oldSysAttMain.setFdOriginId(sysAttMain.getFdId());
            if ("3".equals(SysAttConfigUtil.getOnlineToolType())) {
                oldSysAttMain.setFdPersonId((String)null);
                oldSysAttMain.setFdLastOpenTime((Date)null);
            }
            if (isNewVersion) {
                this.getSysAttMainDao().add((IBaseModel)oldSysAttMain);
            }
            if (StringUtil.isNotNull(oldSysAttMain.getFdFileId())) {
                final SysAttFile attFile = this.sysAttUploadService.getFileById(oldSysAttMain.getFdFileId());
                final ISysFileLocationProxyService sysFileLocationService = SysFileLocationUtil.getProxyService(attFile.getFdAttLocation());
                sysFileLocationService.deleteFile(String.valueOf(attFile.getFdFilePath()) + "_bak");
                if (SysAttMainCoreInnerServiceImp.logger.isDebugEnabled()) {
                    SysAttMainCoreInnerServiceImp.logger.debug("删除上一份bak文件。");
                }
            }
        }
        else {
            if (SysAttMainCoreInnerServiceImp.logger.isDebugEnabled()) {
                SysAttMainCoreInnerServiceImp.logger.debug("编辑附件处理：不存在附件流的情况。");
            }
            if ("pic".equals(sysAttMain.getFdAttType())) {
                final List<?> originals = this.findByModelKey(SysAttMain.class.getName(), sysAttMain.getFdId(), "original");
                if (originals != null && originals.size() != 0) {
                    if (SysAttMainCoreInnerServiceImp.logger.isDebugEnabled()) {
                        SysAttMainCoreInnerServiceImp.logger.debug("处理附件类型为图片（pic）的附件。");
                    }
                    if (sysAttMain.getFdKey() != null && sysAttMain.getFdModelName() != null && sysAttMain.getFdModelId() != null) {
                        final String deleteHql = "delete from " + SysAttMain.class.getName() + " sysAttMain where sysAttMain.fdKey=:fdKey" + " and sysAttMain.fdModelName=:fdModelName" + " and sysAttMain.fdModelId=:fdModelId";
                        final Query query = this.getSysAttMainDao().getHibernateSession().createQuery(deleteHql);
                        query.setParameter("fdKey", (Object)(String.valueOf(sysAttMain.getFdKey()) + "_original"));
                        query.setParameter("fdModelName", (Object)sysAttMain.getFdModelName());
                        query.setParameter("fdModelId", (Object)sysAttMain.getFdModelId());
                        query.executeUpdate();
                    }
                }
                for (int originalIndex = 0; originalIndex < originals.size(); ++originalIndex) {
                    final SysAttMain original = (SysAttMain)originals.get(originalIndex);
                    original.setFdKey(String.valueOf(sysAttMain.getFdKey()) + "_original");
                    original.setFdModelId(sysAttMain.getFdModelId());
                    original.setFdModelName(sysAttMain.getFdModelName());
                    original.setInputStream((InputStream)null);
                    this.getSysAttMainDao().update((IBaseModel)original);
                }
            }
            this.getSysAttMainDao().update(modelObj);
        }
        if (sysAttMain.getAddQueue()) {
            this.getConvertQueueService().addQueueAndPdfUpdate(sysAttMain, oldSysAttMain, sysAttMain.getFdFileId(), sysAttMain.getFdFileName(), sysAttMain.getFdModelName(), sysAttMain.getFdModelId(), "", sysAttMain.getFdId());
            this.getConvertQueueService().addFileToQueue(sysAttMain, oldSysAttMain);
        }
    }
    
    private void markWpsSaveBack(final SysAttMain sysAttMain) {
        int count = 3;
        boolean stop = false;
        while (!stop) {
            if (count-- < 0) {
                SysAttMainCoreInnerServiceImp.logger.warn("发现线程在此尝试获取wpsCenterLockKey超过重试次数" + count + "，开始删除key");
                int removeTryCount = 10;
                while (this.cache.get("wpsCenterSaveMarkLock") != null) {
                    if (removeTryCount-- < 0) {
                        SysAttMainCoreInnerServiceImp.logger.warn("强制删除wpsCenterLockKey失败，可能存在其他线程set该值，当前线程退出");
                        break;
                    }
                    this.cache.remove("wpsCenterSaveMarkLock");
                }
                break;
            }
            final Object o = this.cache.get("wpsCenterSaveMarkLock");
            SysAttMainCoreInnerServiceImp.logger.warn("get SysAttBase.wpsCenterLockKey: " + o);
            if (o == null) {
                if (SysAttMainCoreInnerServiceImp.logger.isDebugEnabled()) {
                    SysAttMainCoreInnerServiceImp.logger.debug("设置wpsCenterLockKey");
                }
                this.cache.put("wpsCenterSaveMarkLock", (Object)"wpsCenterSaveMarkLock");
                try {
                    Object m = this.cache.get("wpsCenterSaveMark");
                    if (m == null) {
                        this.cache.put("wpsCenterSaveMark", (Object)new ConcurrentHashMap());
                        m = this.cache.get("wpsCenterSaveMark");
                    }
                    final ConcurrentHashMap map = (ConcurrentHashMap)m;
                    map.put(sysAttMain.getFdModelId(), sysAttMain.getFdModelName());
                    this.cache.put("wpsCenterSaveMark", (Object)map);
                }
                finally {
                    try {
                        if (SysAttMainCoreInnerServiceImp.logger.isDebugEnabled()) {
                            SysAttMainCoreInnerServiceImp.logger.debug("释放wpsCenterLockKey");
                        }
                        this.cache.remove("wpsCenterSaveMarkLock");
                    }
                    finally {
                        stop = true;
                    }
                    stop = true;
                }
                try {
                    if (SysAttMainCoreInnerServiceImp.logger.isDebugEnabled()) {
                        SysAttMainCoreInnerServiceImp.logger.debug("释放wpsCenterLockKey");
                    }
                    this.cache.remove("wpsCenterSaveMarkLock");
                }
                finally {
                    stop = true;
                }
                stop = true;
            }
            else if (SysAttMainCoreInnerServiceImp.logger.isInfoEnabled()) {
                SysAttMainCoreInnerServiceImp.logger.info("found sAttBase.wpsCenterLockKey, sleep.");
            }
            try {
                if (stop) {
                    continue;
                }
                Thread.sleep(50L);
            }
            catch (final InterruptedException ex) {}
        }
    }
    
    public void deleteAttFile(final String fdId) throws Exception {
        this.sysAttUploadService.deleteRecord(fdId);
    }
    
    public void update(final IBaseModel modelObj) throws Exception {
        this.updateByUser(modelObj, "");
        final SysAttMain sysAttMain = (SysAttMain)modelObj;
        if (("0".equals(SysAttConfigUtil.getOnlineToolType()) && "2".equals(SysAttConfigUtil.isReadJGForMobile())) || ("3".equals(SysAttConfigUtil.getOnlineToolType()) && "2".equals(SysAttConfigUtil.isReadWPSForMobile())) || ("1".equals(SysAttConfigUtil.getOnlineToolType()) && "2".equals(SysAttConfigUtil.isReadWPSCloudForMobile()) && StringUtil.isNotNull(sysAttMain.getFdKey()) && !"originalAtt".equals(sysAttMain.getFdKey()))) {
            SysAttWpsCloudUtil.syncAttToAddByMainId(sysAttMain.getFdId());
        }
    }
    
    public void deleteAtt(final String fdId) throws Exception {
        final SysAttMain sysAttMain = (SysAttMain)this.findByPrimaryKey(fdId, (Object)null, true);
        if (sysAttMain != null) {
            this.delete((IBaseModel)sysAttMain);
        }
    }
    
    public void deleteCoreModels(final IBaseModel mainModel) throws Exception {
        final List coreModels = this.getCoreModels(mainModel, (String)null);
        for (int i = coreModels.size() - 1; i >= 0; --i) {
            this.delete(coreModels.get(i));
        }
    }
    
    public void delete(final IBaseModel modelObj) throws Exception {
        final SysAttMain sysAttMain = (SysAttMain)modelObj;
        UserOperHelper.logDelete((IBaseModel)sysAttMain, sysAttMain.getFdFileName());
        if (StringUtil.isNotNull(sysAttMain.getFdFileId())) {
            this.sysAttUploadService.delete(sysAttMain.getFdFileId());
        }
        else {
            final String tempFilePath = sysAttMain.getFdFilePath();
            if (StringUtil.isNotNull(tempFilePath)) {
                final File tempFile = new File(tempFilePath);
                if (tempFile.exists()) {
                    tempFile.delete();
                }
            }
        }
        this.sysAttDownloadLogService.deleteByAttId(sysAttMain.getFdId());
        this.getSysAttMainDao().delete(modelObj);
    }
    
    public List findByModelKey(final String modelName, final String modelId, final String key) throws Exception {
        return this.getSysAttMainDao().findByModelKey(modelName, modelId, key);
    }
    
    public List findModelKeys(final String modelName, final String modelId) throws Exception {
        return this.getSysAttMainDao().findModelKeys(modelName, modelId);
    }
    
    public List findAttListByModel(final String modelName, final String modelId) throws Exception {
        final List attr = this.getSysAttMainDao().findAttListByModel(modelName, modelId);
        this.setListData(attr);
        return attr;
    }
    
    public Page findPage(final HQLInfo hqlInfo, final String modelName, final String key) throws Exception {
        hqlInfo.setWhereBlock(StringUtil.linkString(hqlInfo.getWhereBlock(), " and ", "sysAttMain.fdModelName =:fdModelName and sysAttMain.fdKey =:fdKey"));
        hqlInfo.setParameter("fdKey", (Object)key);
        hqlInfo.setParameter("fdModelName", (Object)modelName);
        return this.findPage(hqlInfo);
    }
    
    public void findData(final String fdId, final OutputStream out) throws Exception {
        final SysAttMain sysAttMain = (SysAttMain)this.findByPrimaryKey(fdId);
        this.outPutAttData((SysAttBase)sysAttMain, out);
    }
    
    public void findData(final String fdId, final String extend, final OutputStream out) throws Exception {
        final SysAttMain sysAttMain = (SysAttMain)this.findByPrimaryKey(fdId);
        if (StringUtil.isNotNull(sysAttMain.getFdFileId())) {
            sysAttMain.getFdData();
            final InputStream in = this.sysAttUploadService.getFileData(sysAttMain.getFdFileId(), extend);
            IOUtil.write(in, out);
        }
    }
    
    public void findData(final String fdId, final String extend, final OutputStream out, final HttpServletRequest request) throws Exception {
        final SysAttMain sysAttMain = (SysAttMain)this.findByPrimaryKey(fdId);
        if (StringUtil.isNotNull(sysAttMain.getFdFileId())) {
            sysAttMain.getFdData();
            final InputStream in = this.sysAttUploadService.getFileData(sysAttMain.getFdFileId(), extend);
            IOUtil.write(in, out);
        }
    }
    
    public String addRtfData(final SysAttRtfData sysAttRtfData, final InputStream in) throws Exception {
        final String fileId = this.sysAttUploadService.addFile(in, sysAttRtfData.getFdFileName());
        sysAttRtfData.setFdFileId(fileId);
        final String sysAttRtfDataId = this.getSysAttMainDao().add((IBaseModel)sysAttRtfData);
        this.getConvertQueueService().addQueueWithAttMainModelName(fileId, sysAttRtfData.getFdFileName(), sysAttRtfData.getFdModelName(), sysAttRtfData.getFdModelId(), "", sysAttRtfData.getFdId(), SysAttRtfData.class.getName());
        IOUtils.closeQuietly(in);
        return sysAttRtfDataId;
    }
    
    private void proccessRtfPic(final String fileId, InputStream in, final String sing, final int width) throws Exception {
        byte[] imagesByte = null;
        in = this.sysAttUploadService.getFileData(fileId);
        imagesByte = IOUtils.toByteArray(in);
        final ByteArrayInputStream byteIn = new ByteArrayInputStream(imagesByte);
        BufferedImage img = null;
        try {
            img = ImageIO.read(byteIn);
        }
        catch (final IOException ex) {
            SysAttMainCoreInnerServiceImp.logger.warn("该文件不是标准图片类型，不做压缩");
        }
        if (img == null) {
            return;
        }
        final int imgW = img.getWidth();
        final SysAttRtfData sysAttRtfData = new SysAttRtfData();
        sysAttRtfData.setWidth(Integer.valueOf(width));
        sysAttRtfData.setHeight(Integer.valueOf(img.getHeight()));
        sysAttRtfData.setInputStream((InputStream)byteIn);
        if (sysAttRtfData.getInputStream() != null) {
            if (sysAttRtfData.getInputStream().markSupported()) {
                sysAttRtfData.getInputStream().reset();
            }
            sysAttRtfData.setFdAttType("pic");
            final SysAttFile sysAttFile = this.sysAttUploadService.getFileById(fileId);
            if (width == 0 || width >= imgW) {
                this.sysAttUploadService.deleteFile(sysAttFile, sing);
            }
            else {
                this.addComprassFile(sysAttRtfData, sysAttFile, sing);
            }
        }
        IOUtils.closeQuietly(in);
    }
    
    public void findRtfData(final String fdId, final OutputStream out, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final SysAttRtfData sysAttRtfData = this.findRtfDataByPrimaryKey(fdId);
        this.outPutRtfData((SysAttBase)sysAttRtfData, out, request, response);
    }
    
    public SysAttMain clone(final SysAttMain sysAttMain) throws Exception {
        return this.clone(sysAttMain, false);
    }
    
    public SysAttMain clone(final SysAttMain sysAttMain, final Boolean newFileId) throws Exception {
        if (SysAttMainCoreInnerServiceImp.logger.isDebugEnabled()) {
            SysAttMainCoreInnerServiceImp.logger.debug("废弃的克隆接口，逻辑已优化不产生中间文件。");
        }
        String attFileId = sysAttMain.getFdFileId();
        final String attMainId = sysAttMain.getFdId();
        if (StringUtil.isNull(attFileId) && StringUtil.isNotNull(attMainId)) {
            final SysAttMain main = (SysAttMain)this.getSysAttMainDao().findByPrimaryKey(attMainId);
            if (main != null) {
                attFileId = main.getFdFileId();
            }
        }
        final SysAttFile sysAttFile = this.sysAttUploadService.getFileById(attFileId);
        if (sysAttFile == null) {
            SysAttMainCoreInnerServiceImp.logger.error("克隆的附件对象对应的数据库sysFileAtt记录不存在,attFileId = {}", attFileId);
            throw new RuntimeException("克隆的附件对象对应的数据库sysFileAtt记录不存在,请查看后台日志！");
        }
        final String fdAttLocation = sysAttFile.getFdAttLocation();
        final String relativePath = this.sysAttUploadService.getAbsouluteFilePath(sysAttFile);
        if (SysAttMainCoreInnerServiceImp.logger.isDebugEnabled()) {
            SysAttMainCoreInnerServiceImp.logger.debug("调用文件服务进行附件拷贝，fdAttLocation = {}, relativePath = {}", fdAttLocation, relativePath);
        }
        final SysAttMain copyAtt = (SysAttMain)sysAttMain.clone();
        copyAtt.setFdId(IDGenerator.generateID());
        copyAtt.setFdCreatorId(UserUtil.getUser().getFdId());
        copyAtt.setDocCreateTime(new Date());
        InputStream is = null;
        try {
            is = SysFileLocationUtil.getProxyService(fdAttLocation).readFile(relativePath, (sysAttFile.getFdCata() != null) ? sysAttFile.getFdCata().getFdPath() : null);
            copyAtt.setInputStream(is);
            copyAtt.setFdModelId((String)null);
            copyAtt.setFdFileId((String)null);
            copyAtt.setFdFilePath((String)null);
            this.add((IBaseModel)copyAtt, newFileId);
        }
        finally {
            IOUtils.closeQuietly(is);
        }
        IOUtils.closeQuietly(is);
        return copyAtt;
    }
    
    public SysAttMain cloneEasy(final SysAttMain sysAttMain) throws Exception {
        if (sysAttMain == null) {
            SysAttMainCoreInnerServiceImp.logger.error("需要克隆的附件对象为空");
            throw new RuntimeException("需要克隆的附件对象为空");
        }
        String attFileId = sysAttMain.getFdFileId();
        final String attMainfdId = sysAttMain.getFdId();
        if (StringUtil.isNull(attFileId) && StringUtil.isNotNull(attMainfdId)) {
            final SysAttMain main = (SysAttMain)this.getSysAttMainDao().findByPrimaryKey(attMainfdId);
            if (main != null) {
                attFileId = main.getFdFileId();
            }
        }
        if (StringUtil.isNull(attFileId) || this.sysAttUploadService.getFileById(attFileId) == null) {
            SysAttMainCoreInnerServiceImp.logger.error("克隆的附件对象对应的数据库sysFileAtt记录不存在,attFileId = {}", attFileId);
            throw new RuntimeException("克隆的附件对象对应的数据库sysFileAtt记录不存在,请查看后台日志！");
        }
        final SysAttMain cloneMain = (SysAttMain)sysAttMain.clone();
        cloneMain.setFdId(IDGenerator.generateID());
        cloneMain.setFdCreatorId(UserUtil.getUser().getFdId());
        cloneMain.setDocCreateTime(new Date());
        cloneMain.setFdFileId(attFileId);
        this.add((IBaseModel)cloneMain, false);
        return cloneMain;
    }
    
    public SysAttMain cloneDeeply(final SysAttMain sysAttMain) throws Exception {
        if (SysAttMainCoreInnerServiceImp.logger.isDebugEnabled()) {
            SysAttMainCoreInnerServiceImp.logger.debug("复制附件处理：不存在附件流的情况。");
        }
        if (sysAttMain == null) {
            SysAttMainCoreInnerServiceImp.logger.error("需要克隆的附件对象为空");
            throw new RuntimeException("需要克隆的附件对象为空");
        }
        String attFileId = sysAttMain.getFdFileId();
        final String attMainId = sysAttMain.getFdId();
        if (StringUtil.isNull(attFileId) && StringUtil.isNotNull(attMainId)) {
            final SysAttMain main = (SysAttMain)this.getSysAttMainDao().findByPrimaryKey(attMainId);
            if (main != null) {
                attFileId = main.getFdFileId();
            }
        }
        final SysAttFile sysAttFile = this.sysAttUploadService.getFileById(attFileId);
        if (sysAttFile == null) {
            SysAttMainCoreInnerServiceImp.logger.error("克隆的附件对象对应的数据库sysFileAtt记录不存在,attFileId = {}", attFileId);
            throw new RuntimeException("克隆的附件对象对应的数据库sysFileAtt记录不存在,请查看后台日志！");
        }
        final String fdAttLocation = sysAttFile.getFdAttLocation();
        final String prefixPath = (sysAttFile.getFdCata() != null) ? sysAttFile.getFdCata().getFdPath() : null;
        final String relativePath = this.sysAttUploadService.getAbsouluteFilePath(sysAttFile);
        if (SysAttMainCoreInnerServiceImp.logger.isDebugEnabled()) {
            SysAttMainCoreInnerServiceImp.logger.debug("调用文件服务进行附件拷贝，fdAttLocation = {}, relativePath = {}", fdAttLocation, relativePath);
        }
        final String copyPath = this.copyFile(fdAttLocation, relativePath, prefixPath);
        if (SysAttMainCoreInnerServiceImp.logger.isDebugEnabled()) {
            SysAttMainCoreInnerServiceImp.logger.debug("拷贝后相对路径，copyPath = {}", copyPath);
        }
        final String copyFileId = this.genrateFileIdByPath(copyPath);
        final SysAttFile copyAttFile = this.sysAttUploadService.addFile(copyFileId, (long)sysAttFile.getFdFileSize(), MD5Util.getMD5String(IDGenerator.generateID()), copyPath);
        final SysAttMain copyAtt = (SysAttMain)sysAttMain.clone();
        copyAtt.setFdId(IDGenerator.generateID());
        copyAtt.setFdCreatorId(UserUtil.getUser().getFdId());
        copyAtt.setDocCreateTime(new Date());
        copyAtt.setFdFileId(copyAttFile.getFdId());
        copyAtt.setFdModelId((String)null);
        copyAtt.setFdFilePath((String)null);
        this.add((IBaseModel)copyAtt);
        return copyAtt;
    }
    
    public SysAttRtfData findRtfDataByPrimaryKey(final String fdId) throws Exception {
        return this.getSysAttMainDao().findRtfDataByPrimaryKey(fdId);
    }
    
    public List findAttData(final Date begin, final Date end) throws Exception {
        final List attList = this.getSysAttMainDao().findAttData(begin, end);
        this.setListData(attList);
        return attList;
    }
    
    public List findModelsByIds(final String[] fdId) throws Exception {
        final List attList = this.getSysAttMainDao().findModelsByIds(fdId);
        this.setListData(attList);
        return attList;
    }
    
    public List update(final List sysAttMains) throws Exception {
        for (final SysAttMain sysAttMain : sysAttMains) {
            this.update((IBaseModel)sysAttMain);
        }
        return sysAttMains;
    }
    
    public String addAttachment(final IBaseModel model, final String fdKey, final byte[] content, final String fileName, final String fdAttType, final boolean newFileId) throws Exception {
        return this.addAttachment(model, fdKey, content, fileName, fdAttType, newFileId, null);
    }
    
    public String addAttachment(final IBaseModel model, final String fdKey, final byte[] content, final String fileName, final String fdAttType, final boolean newFileId, final Integer fdOrder) throws Exception {
        return this.addAttachment(model, fdKey, content, fileName, fdAttType, newFileId, fdOrder, true);
    }
    
    public String addAttachment(final IBaseModel model, final String fdKey, final byte[] content, final String fileName, final String fdAttType, final boolean newFileId, final Integer fdOrder, final boolean addQueue) throws Exception {
        final SysAttMain sysAttMain = new SysAttMain();
        sysAttMain.setDocCreateTime(new Date());
        sysAttMain.setFdFileName(fileName);
        sysAttMain.setFdSize(Double.valueOf((double)content.length));
        sysAttMain.setFdFileName(fileName);
        sysAttMain.setDocCreateTime(new Date());
        final String contentType = FileMimeTypeUtil.getContentType(fileName);
        sysAttMain.setFdContentType(contentType);
        sysAttMain.setInputStream((InputStream)new ByteArrayInputStream(content));
        sysAttMain.setFdKey(fdKey);
        sysAttMain.setFdModelId(model.getFdId());
        final String modelName = ModelUtil.getModelClassName((Object)model);
        sysAttMain.setFdModelName(modelName);
        sysAttMain.setFdAttType(fdAttType);
        sysAttMain.setFdOrder(fdOrder);
        sysAttMain.setAddQueue(Boolean.valueOf(addQueue));
        this.add((IBaseModel)sysAttMain, newFileId, addQueue);
        return "/sys/attachment/sys_att_main/sysAttMain.do?method=download&fdId=" + sysAttMain.getFdId();
    }
    
    public String addAttachment(final IBaseModel model, final String fdKey, final byte[] content, final String fileName, final String fdAttType) throws Exception {
        return this.addAttachment(model, fdKey, content, fileName, fdAttType, false);
    }
    
    public SysAttMain addAttachment(final IBaseModel model, final String fdKey, final InputStream content, final String fileName, final String fdAttType, final Double fileSize, final String pathName) throws Exception {
        final SysAttMain sysAttMain = new SysAttMain();
        sysAttMain.setDocCreateTime(new Date());
        sysAttMain.setFdFileName(fileName);
        sysAttMain.setFdSize(fileSize);
        sysAttMain.setFdFileName(fileName);
        sysAttMain.setDocCreateTime(new Date());
        final String contentType = FileMimeTypeUtil.getContentType(fileName);
        sysAttMain.setFdContentType(contentType);
        sysAttMain.setInputStream(content);
        sysAttMain.setFdKey(fdKey);
        sysAttMain.setFdModelId(model.getFdId());
        final String modelName = ModelUtil.getModelClassName((Object)model);
        sysAttMain.setFdModelName(modelName);
        sysAttMain.setFdAttType(fdAttType);
        this.add((IBaseModel)sysAttMain, pathName);
        return sysAttMain;
    }
    
    public SysAttMain addAttachment(final String fdModelId, final String fdModelName, final String fdKey, final byte[] content, final String fileName, final String fdAttType) throws Exception {
        final SysAttMain sysAttMain = new SysAttMain();
        sysAttMain.setDocCreateTime(new Date());
        sysAttMain.setFdFileName(fileName);
        sysAttMain.setFdSize(Double.valueOf((double)content.length));
        sysAttMain.setFdFileName(fileName);
        sysAttMain.setDocCreateTime(new Date());
        final String contentType = FileMimeTypeUtil.getContentType(fileName);
        sysAttMain.setFdContentType(contentType);
        sysAttMain.setInputStream((InputStream)new ByteArrayInputStream(content));
        sysAttMain.setFdKey(fdKey);
        sysAttMain.setFdModelId(fdModelId);
        sysAttMain.setFdModelName(fdModelName);
        sysAttMain.setFdAttType(fdAttType);
        this.add((IBaseModel)sysAttMain);
        return sysAttMain;
    }
    
    public SysAttMain addAttachment(final String fdModelId, final String fdModelName, final String fdKey, final byte[] content, final String fileName, final String fdAttType, final Boolean addQueue) throws Exception {
        final SysAttMain sysAttMain = new SysAttMain();
        sysAttMain.setDocCreateTime(new Date());
        sysAttMain.setFdFileName(fileName);
        sysAttMain.setFdSize(Double.valueOf((double)content.length));
        sysAttMain.setFdFileName(fileName);
        sysAttMain.setDocCreateTime(new Date());
        final String contentType = FileMimeTypeUtil.getContentType(fileName);
        sysAttMain.setFdContentType(contentType);
        sysAttMain.setInputStream((InputStream)new ByteArrayInputStream(content));
        sysAttMain.setFdKey(fdKey);
        sysAttMain.setFdModelId(fdModelId);
        sysAttMain.setFdModelName(fdModelName);
        sysAttMain.setFdAttType(fdAttType);
        this.add((IBaseModel)sysAttMain, false, addQueue);
        return sysAttMain;
    }
    
    private String add(final IBaseModel modelObj, final String pathName) throws Exception {
        final SysAttMain sysAttMain = (SysAttMain)modelObj;
        String fileId = sysAttMain.getFdFileId();
        if (StringUtil.isNotNull(fileId)) {
            if (sysAttMain.getFdSize() == null || sysAttMain.getFdSize() == 0.0) {
                final SysAttFile attFile = this.sysAttUploadService.getFileById(fileId);
                sysAttMain.setFdSize(Double.valueOf((double)attFile.getFdFileSize()));
            }
            if (SysAttMainCoreInnerServiceImp.logger.isDebugEnabled()) {
                SysAttMainCoreInnerServiceImp.logger.debug("增加附件信息：上传文件后，再增加附件信息情况。");
            }
        }
        else {
            fileId = this.sysAttUploadService.addFile((String)null, (long)sysAttMain.getInputStream().available(), sysAttMain.getInputStream(), false, pathName, sysAttMain.getFdFileName());
            sysAttMain.setFdFileId(fileId);
            sysAttMain.setInputStream((InputStream)null);
            if (SysAttMainCoreInnerServiceImp.logger.isDebugEnabled()) {
                SysAttMainCoreInnerServiceImp.logger.debug("增加附件信息：文件流随附件信息一起传递情况。");
            }
        }
        if (StringUtil.isNull(sysAttMain.getFdCreatorId())) {
            sysAttMain.setFdCreatorId(UserUtil.getUser().getFdId());
        }
        this.getConvertQueueService().addQueue(sysAttMain.getFdFileId(), sysAttMain.getFdFileName(), sysAttMain.getFdModelName(), sysAttMain.getFdModelId(), "", sysAttMain.getFdId());
        return this.getSysAttMainDao().add((IBaseModel)sysAttMain);
    }
    
    public String addSingleAttachment(final IBaseModel model, final String fdKey, final byte[] content, final String fileName, final String fdAttType) throws Exception {
        this.getSysAttMainDao().clearAttachment(model, fdKey);
        return this.addAttachment(model, fdKey, content, fileName, fdAttType);
    }
    
    public void delete(final IBaseModel model, final String fdKey) throws Exception {
        final List list = this.getCorePropsModels(model, fdKey);
        if (list != null && list.size() > 0) {
            for (int i = 0; i < list.size(); ++i) {
                final Object[] row = list.get(i);
                this.sysAttDownloadLogService.deleteByAttId(row[0].toString());
            }
        }
        this.getSysAttMainDao().clearAttachment(model, fdKey);
    }
    
    public List getCorePropsModels(final IBaseModel mainModel, final String key) throws Exception {
        return this.getSysAttMainDao().getCorePropsModels(mainModel, key);
    }
    
    private void outPutAttData(final SysAttBase sysAttMain, final OutputStream out) throws Exception {
        InputStream in = null;
        in = this.getIntputStream(sysAttMain, false);
        IOUtil.write(in, out);
    }
    
    private void outPutRtfData(final SysAttBase sysAttMain, final OutputStream out, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        InputStream in = null;
        if (StringUtil.isNotNull(sysAttMain.getFdFileId())) {
            final String picthumb = request.getParameter("picthumb");
            if ("original".equals(picthumb)) {
                in = this.sysAttUploadService.getFileData(sysAttMain.getFdFileId());
            }
            else {
                try {
                    in = this.sysAttUploadService.getFileData(sysAttMain.getFdFileId(), picthumb);
                }
                catch (final Exception ex) {
                    SysAttMainCoreInnerServiceImp.logger.debug("获取rtf压缩图片异常");
                }
                if (StringUtil.isNull(picthumb) || in == null || in.available() == 0) {
                    in = this.sysAttUploadService.getFileData(sysAttMain.getFdFileId());
                }
                else {
                    final byte[] inputSreamByt = IOUtils.toByteArray(in);
                    if (!ServerUtil.isWebLogic()) {
                        response.setContentLength(inputSreamByt.length);
                    }
                    in = new ByteArrayInputStream(inputSreamByt);
                }
            }
        }
        else if (SysAttMain.ATTACHMENT_LOCATION_DB.equalsIgnoreCase(sysAttMain.getFdAttLocation())) {
            if (sysAttMain.getFdData() != null && sysAttMain.getFdData().getBinaryStream() != null) {
                in = sysAttMain.getFdData().getBinaryStream();
            }
        }
        else if (SysAttMain.ATTACHMENT_LOCATION_FILE.equalsIgnoreCase(sysAttMain.getFdAttLocation())) {
            in = new FileInputStream(sysAttMain.getFdFilePath());
        }
        IOUtil.write(in, out);
        if (ServerUtil.isWebLogic()) {
            response.flushBuffer();
        }
    }
    
    private void setListData(final List attData) throws Exception {
        for (int i = 0; i < attData.size(); ++i) {
            final SysAttMain attMain = attData.get(i);
            attMain.setInputStream(this.getIntputStream((SysAttBase)attMain, true));
        }
    }
    
    public InputStream getInputStream(final String id) throws Exception {
        return this.getInputStream((SysAttMain)this.getSysAttMainDao().findByPrimaryKey(id));
    }
    
    public InputStream getInputStreamByFile(final String fileId) throws Exception {
        if (StringUtil.isNotNull(fileId)) {
            return this.sysAttUploadService.getFileData(fileId);
        }
        return null;
    }
    
    public InputStream getInputStream(final SysAttMain sysAttMain) throws Exception {
        return this.getIntputStream((SysAttBase)sysAttMain, true);
    }
    
    private InputStream getIntputStream(final SysAttBase sysAttMain, final boolean changeToFile) throws Exception {
        InputStream in = null;
        try {
            if (StringUtil.isNotNull(sysAttMain.getFdFileId())) {
                in = this.sysAttUploadService.getFileData(sysAttMain.getFdFileId());
            }
            else if (SysAttMain.ATTACHMENT_LOCATION_DB.equalsIgnoreCase(sysAttMain.getFdAttLocation())) {
                if (sysAttMain.getFdData() != null && sysAttMain.getFdData().getBinaryStream() != null) {
                    if (changeToFile) {
                        final File tempFile = File.createTempFile("sys_attachment", "tmp");
                        FileOutputStream fos = null;
                        try {
                            fos = new FileOutputStream(tempFile);
                            if (SysAttMainCoreInnerServiceImp.logger.isDebugEnabled()) {
                                SysAttMainCoreInnerServiceImp.logger.debug("Read to copy sysAttMain[" + sysAttMain.getFdId() + "] to file: " + tempFile.getAbsolutePath());
                            }
                            IOUtil.write((InputStream)new DecryptionInputStream(sysAttMain.getFdData().getBinaryStream()), (OutputStream)fos);
                            in = new FileInputStream(tempFile);
                        }
                        finally {
                            if (fos != null) {
                                try {
                                    fos.close();
                                }
                                catch (final IOException ex) {}
                            }
                        }
                        if (fos != null) {
                            try {
                                fos.close();
                            }
                            catch (final IOException ex2) {}
                        }
                    }
                    else {
                        in = (InputStream)new DecryptionInputStream(sysAttMain.getFdData().getBinaryStream());
                    }
                }
            }
            else if (SysAttMain.ATTACHMENT_LOCATION_FILE.equalsIgnoreCase(sysAttMain.getFdAttLocation())) {
                in = (InputStream)new DecryptionInputStream((InputStream)new FileInputStream(sysAttMain.getFdFilePath()));
            }
        }
        catch (final Exception ex3) {
            IOUtils.closeQuietly(in);
        }
        return in;
    }
    
    public void updateClearAtt(final SysQuartzJobContext context) throws Exception {
        final Session session = this.getBaseDao().getHibernateSession();
        Calendar attExpireCal = Calendar.getInstance();
        attExpireCal.set(5, attExpireCal.get(5) - 1);
        Query q = (Query)session.createNativeQuery("select fd_id from sys_att_main where (fd_model_id is null or fd_model_id = '') and doc_create_time <= :attExpireCal ").setParameter("attExpireCal", (Object)attExpireCal.getTime());
        List attIdList = q.list();
        if (!attIdList.isEmpty()) {
            this.delete((String[])attIdList.toArray(new String[attIdList.size()]));
            context.logMessage("清理无用的附件信息(SysAttMain),共计" + attIdList.size() + "条。");
        }
        attIdList = null;
        String expireCfg = ResourceUtil.getKmssConfigString("sys.att.slice.expire");
        if (StringUtil.isNull(expireCfg)) {
            expireCfg = "1";
        }
        final int monthExpire = Integer.valueOf(expireCfg);
        attExpireCal = Calendar.getInstance();
        attExpireCal.set(2, attExpireCal.get(2) - monthExpire);
        String where = " WHERE fd_file_id not in (SELECT fd_file_id FROM sys_att_main WHERE fd_file_id IS NOT NULL UNION SELECT fd_file_id FROM sys_att_rtf_data WHERE fd_file_id IS NOT NULL) and fd_delete_time <:timpStampVal";
        q = (Query)session.createNativeQuery("SELECT fd_file_id FROM sys_att_tmp" + where).setParameter("timpStampVal", (Object)attExpireCal.getTime());
        attIdList = q.list();
        if (!attIdList.isEmpty()) {
            for (int i = 0; i < attIdList.size(); ++i) {
                this.sysAttUploadService.delete((String)attIdList.get(i), true);
            }
            final NativeQuery nativeQuery = session.createNativeQuery("delete from sys_att_tmp" + where);
            final int tmpCount = nativeQuery.addSynchronizedQuerySpace("sys_att_tmp").setParameter("timpStampVal", (Object)attExpireCal.getTime()).executeUpdate();
            context.logMessage("清理无用 的附件关联信息(SysAttTmp),共计" + tmpCount + "条,删除相关联的文件信息" + attIdList.size() + "条。");
        }
        attIdList = null;
        where = " WHERE fd_id not in (SELECT fd_file_id FROM sys_att_main WHERE fd_file_id IS NOT NULL UNION SELECT fd_file_id FROM sys_att_rtf_data WHERE fd_file_id IS NOT NULL) and doc_create_time <:timpStampVal";
        final NativeQuery nativeQuery = session.createNativeQuery("SELECT fd_id FROM sys_att_file" + where);
        q = (Query)nativeQuery.addSynchronizedQuerySpace("sys_att_file").setParameter("timpStampVal", (Object)attExpireCal.getTime());
        attIdList = q.list();
        if (!attIdList.isEmpty()) {
            for (int j = 0; j < attIdList.size(); ++j) {
                this.sysAttUploadService.delete((String)attIdList.get(j), true);
            }
            context.logMessage("清理没有使用的附件信息(SysAttFile),共计" + attIdList.size() + "条,删除相关联的文件信息" + attIdList.size() + "条。");
        }
        attIdList = null;
        q = (Query)session.createNativeQuery("select fd_file_id from sys_att_file_slice where fd_modify_time <:timpStampVal group by fd_file_id").setParameter("timpStampVal", (Object)attExpireCal.getTime().getTime());
        attIdList = q.list();
        if (!attIdList.isEmpty()) {
            for (int j = 0; j < attIdList.size(); ++j) {
                this.sysAttUploadService.delete((String)attIdList.get(j), true);
            }
            context.logMessage("清理未上传完的附件信息(SysAttFile),共计" + attIdList.size() + "条。");
        }
        attIdList = null;
        final String videoEnabled = ResourceUtil.getKmssConfigString("kmss.att.video.enabled");
        if (videoEnabled != null && "true".equals(videoEnabled.trim())) {
            q = (Query)session.createNativeQuery("select sys_att_video.fd_id,sys_att_video.fd_file_path from Sys_att_video sys_att_video where sys_att_video.fd_att_id not in(select sys_att_main.fd_id from Sys_att_main sys_att_main) and sys_att_video.fd_create_time <:timpStampVal").setParameter("timpStampVal", (Object)attExpireCal.getTime());
            attIdList = q.list();
            if (!attIdList.isEmpty()) {
                for (int k = 0; k < attIdList.size(); ++k) {
                    final Object[] array = attIdList.get(k);
                }
                context.logMessage("清理视频附件信息(SysAttVideo),共计" + attIdList.size() + "条。");
            }
        }
    }
    
    public void delTmpFile(final SysQuartzJobContext context) throws Exception {
        MessageCenter.getInstance().sendToOther((IMessage)new TmpCleanMessage(this.runnabled));
        final long dateNum = System.currentTimeMillis() - 7200000L;
        final String dirPath = FileUtil.getSystemTempPath();
        if (StringUtil.isNull(dirPath)) {
            return;
        }
        final File directory = new File(dirPath);
        final File[] files = directory.listFiles();
        if (files == null) {
            return;
        }
        SysAttMainCoreInnerServiceImp.logger.info("开始清理临时文件夹：" + directory.getAbsolutePath());
        File[] array;
        for (int length = (array = files).length, i = 0; i < length; ++i) {
            final File file = array[i];
            if (file.isFile() && dateNum > file.lastModified()) {
                try {
                    if (file.delete()) {
                        SysAttMainCoreInnerServiceImp.logger.info("删除文件：" + file.getName() + " 成功！");
                        if (context != null) {
                            context.logMessage("删除文件：" + file.getName() + " 成功！");
                        }
                    }
                }
                catch (final Exception e) {
                    SysAttMainCoreInnerServiceImp.logger.error("无法删除文件：" + file.getPath(), e);
                }
            }
        }
    }
    
    public IMessageQueue getMessageQueue() {
        return this.messageQueue;
    }
    
    public void receiveMessage(final IMessage message) throws Exception {
        if (((TmpCleanMessage)message).isImmediateRun()) {
            this.runnabled = false;
            this.delTmpFile(null);
        }
    }
    
    private String formatSize(final String filesize) throws Exception {
        String result = "";
        if (filesize != null) {
            final BigDecimal Num = new BigDecimal(filesize);
            double size = Num.doubleValue();
            if (size < 1024.0) {
                result = String.valueOf(size) + "B";
            }
            else {
                size = (double)(Math.round(size * 100.0 / 1024.0) / 100L);
                if (size < 1024.0) {
                    result = String.valueOf(size) + "KB";
                }
                else {
                    size = (double)(Math.round(size * 100.0 / 1024.0) / 100L);
                    if (size < 1024.0) {
                        result = String.valueOf(size) + "M";
                    }
                    else {
                        size = (double)(Math.round(size * 100.0 / 1024.0) / 100L);
                        result = String.valueOf(size) + "G";
                    }
                }
            }
        }
        return result;
    }
    
    public JSONArray findFilePath(final String fdDocIds) throws Exception {
        final JSONArray jsonArr = new JSONArray();
        final Session session = this.getBaseDao().getHibernateSession();
        final String sql = "select a.fd_file_name,a.fd_key,a.fd_size,f.fd_id,a.fd_model_id,a.fd_model_name from sys_att_file f left join sys_att_main a on f.fd_id = a.fd_file_id where a.fd_model_id in ('" + fdDocIds.replace(";", "','") + "')";
        final Query q = (Query)session.createNativeQuery(sql);
        final List attList = q.list();
        for (int i = 0; i < attList.size(); ++i) {
            final Object[] obj = attList.get(i);
            final JSONObject jsonObj = new JSONObject();
            jsonObj.put((Object)"fdFileName", obj[0]);
            jsonObj.put((Object)"fdKey", obj[1]);
            final String fdSize = obj[2].toString();
            jsonObj.put((Object)"fdSize", (Object)this.formatSize(fdSize));
            final String FilePath = this.sysAttUploadService.getAbsouluteFilePath((String)obj[3]);
            final String bakf = String.valueOf(FilePath) + "_bak";
            final SysAttFile file = this.sysAttUploadService.getFileById((String)obj[3]);
            final String pathPrefix = (file.getFdCata() == null) ? null : file.getFdCata().getFdPath();
            if (SysFileLocationUtil.getProxyService(file.getFdAttLocation()).doesFileExist(bakf, pathPrefix)) {
                jsonObj.put((Object)"fdExist", (Object)"true");
            }
            else {
                jsonObj.put((Object)"fdExist", (Object)"false");
            }
            jsonObj.put((Object)"fdFilePath", (Object)FilePath);
            final SysDictModel model = SysDataDict.getInstance().getModel((String)obj[5]);
            if (model != null && !StringUtil.isNull(model.getUrl())) {
                jsonObj.put((Object)"fdLink", (Object)formatModelUrl((String)obj[4], model.getUrl()));
            }
            jsonArr.add((Object)jsonObj);
        }
        return jsonArr;
    }
    
    public JSONObject restorefile(final String[] filePath) throws Exception {
        final JSONObject jsonObj = new JSONObject();
        final List<String> successList = new ArrayList<String>();
        final List<String> failList = new ArrayList<String>();
        final ISysFileLocationProxyService sysFileLocationService = SysFileLocationUtil.getProxyService();
        for (int i = 0; i < filePath.length; ++i) {
            final String bakFile = String.valueOf(filePath[i]) + "_bak";
            final SysAttFile attFile = this.sysAttUploadService.getFileByPath(bakFile);
            final String pathPrefix = (attFile.getFdCata() == null) ? null : attFile.getFdCata().getFdPath();
            if (SysFileLocationUtil.getProxyService(attFile.getFdAttLocation()).doesFileExist(bakFile, pathPrefix)) {
                final InputStream bakFileInputStream = SysFileLocationUtil.getProxyService(attFile.getFdAttLocation()).readFile(bakFile, pathPrefix);
                sysFileLocationService.writeFile(bakFileInputStream, filePath[i]);
                IOUtils.closeQuietly(bakFileInputStream);
                successList.add(filePath[i]);
            }
            else {
                failList.add(filePath[i]);
            }
        }
        jsonObj.put((Object)"success", (Object)successList);
        jsonObj.put((Object)"fail", (Object)failList);
        return jsonObj;
    }
    
    private static String formatModelUrl(final String value, String url) {
        if (StringUtil.isNull(url)) {
            return null;
        }
        final Pattern p = Pattern.compile("\\$\\{([^}]+)\\}");
        final Matcher m = p.matcher(url);
        while (m.find()) {
            final String property = m.group(1);
            try {
                url = StringUtil.replace(url, "${" + property + "}", value);
            }
            catch (final Exception ex) {}
        }
        return url;
    }
    
    public void addDownloadCount(final String attId) throws Exception {
        final String hql = "update SysAttMain set downloadSum = downloadSum + 1 where fdId = :fdId";
        this.getBaseDao().getHibernateSession().createQuery(hql).setParameter("fdId", (Object)attId).executeUpdate();
    }
    
    public JSONObject findMainDocInfo(final String fdId) throws Exception {
        final JSONObject info = new JSONObject();
        final SysAttMain main = (SysAttMain)this.findByPrimaryKey(fdId, (Object)null, true);
        if (main != null) {
            final String fdModelId = main.getFdModelId();
            final String fdModelName = main.getFdModelName();
            if (StringUtil.isNotNull(fdModelId) && StringUtil.isNotNull(fdModelName)) {
                final SysDictModel docModel = SysDataDict.getInstance().getModel(fdModelName);
                if (docModel != null) {
                    final IBaseService docService = (IBaseService)SpringBeanUtil.getBean(docModel.getServiceBean());
                    final IBaseModel model = docService.findByPrimaryKey(fdModelId, (Object)null, true);
                    final String url = ModelUtil.getModelUrl((Object)model);
                    info.put((Object)"url", (Object)url);
                }
            }
        }
        return info;
    }
    
    public void addFile(final String fdMd5, final String fdFileSize, final String fdId, final String fdPath) throws Exception {
        this.sysAttUploadService.addFile(fdId, (long)Long.valueOf(fdFileSize), fdMd5, fdPath);
    }
    
    public String getFilePath(final String fdId) throws Exception {
        final SysAttMain sysAttMain = (SysAttMain)this.findByPrimaryKey(fdId);
        return this.sysAttUploadService.getFileById(sysAttMain.getFdFileId()).getFdFilePath();
    }
    
    public SysAttFile getFile(final String fdId) throws Exception {
        final SysAttMain sysAttMain = (SysAttMain)this.findByPrimaryKey(fdId);
        if (sysAttMain == null) {
            return null;
        }
        return this.sysAttUploadService.getFileById(sysAttMain.getFdFileId());
    }
    
    public SysAttFile getFileByFileId(final String fileId) throws Exception {
        if (StringUtil.isNull(fileId)) {
            return null;
        }
        return this.sysAttUploadService.getFileById(fileId);
    }
    
    public SysAttFile getFileByPath(final String filePath) throws Exception {
        return this.sysAttUploadService.getFileByPath(filePath);
    }
    
    public SysAttMain getAttMainByPath(final String filePath) throws Exception {
        final SysAttFile attFile = this.sysAttUploadService.getFileByPath(filePath);
        if (StringUtil.isNull(attFile.getFdFilePath())) {
            return null;
        }
        final HQLInfo hql = new HQLInfo();
        hql.setModelName(SysAttMain.class.getName());
        hql.setWhereBlock("fdFileId=:fdFileId");
        hql.setParameter("fdFileId", (Object)attFile.getFdId());
        hql.setOrderBy("docCreateTime asc");
        final SysAttMain obj = (SysAttMain)this.findFirstOne(hql);
        return obj;
    }
    
    public SysAttFile getFileByMd5(final String fileMd5, final long fileSize) throws Exception {
        return this.sysAttUploadService.getFileByMd5(fileMd5, fileSize);
    }
    
    public boolean validateDownloadSignature(final String expires, final String fdId, final String sign) throws Exception {
        final boolean auth = this.checkDownloadSignature(sign, expires, fdId);
        if (auth) {
            SysAttMainCoreInnerServiceImp.logger.info("SysAttachmentSignValidator.validate success,no need to login. download attMainId:" + fdId + "\nexpires:" + expires + ",sign:" + sign);
            return true;
        }
        return false;
    }
    
    public boolean validateDownloadSignatureRest(final String expires, final String fdId, final String sign) throws Exception {
        final boolean auth = this.checkDownloadSignatureRest(sign, expires, fdId);
        if (auth) {
            SysAttMainCoreInnerServiceImp.logger.info("SysAttachmentSignValidator.validate success,no need to login. download attMainId:" + fdId + "\nexpires:" + expires + ",sign:" + sign);
            return true;
        }
        return false;
    }
    
    private boolean checkDownloadSignature(String sign, final String expires, final String fdId) throws Exception {
        boolean auth = false;
        if (StringUtil.isNotNull(sign) && StringUtil.isNotNull(expires)) {
            sign = sign.replaceAll(" ", "+");
            final long expiresTime = Long.valueOf(expires);
            if (expiresTime < System.currentTimeMillis()) {
                return false;
            }
            final String signStr = String.valueOf(expires) + ":" + fdId;
            final ISysWebserviceMainService sysWsMainService = (ISysWebserviceMainService)SpringBeanUtil.getBean("sysWebserviceMainService");
            final SysWebserviceMain sysWsMain = sysWsMainService.findByServiceBean("coWritingWSService");
            final List<SysWebserviceUser> webUsers = sysWsMain.getFdUser();
            if (ArrayUtil.isEmpty((List)webUsers)) {
                return false;
            }
            for (final SysWebserviceUser webUser : webUsers) {
                final String calcSign = SignUtil.getHMAC(String.valueOf(signStr) + ":" + webUser.getFdUserName(), StringUtil.isNotNull(webUser.getFdPassword()) ? webUser.getFdPassword() : webUser.getFdId());
                if (sign.equals(calcSign)) {
                    auth = true;
                    break;
                }
            }
        }
        return auth;
    }
    
    private boolean checkDownloadSignatureRest(String sign, final String expires, final String fdId) throws Exception {
        boolean auth = false;
        String redisSign = null;
        boolean isTwice = false;
        if (StringUtil.isNotNull(sign) && StringUtil.isNotNull(expires)) {
            sign = sign.replaceAll(" ", "+");
            if (SysAttUtil.tokenCache.get(sign) != null) {
                redisSign = (String)SysAttUtil.tokenCache.get(sign);
            }
            final long expiresTime = Long.valueOf(expires);
            if (expiresTime < System.currentTimeMillis()) {
                return false;
            }
            try {
                if (StringUtil.isNotNull(redisSign)) {
                    Integer.valueOf(redisSign).intValue();
                }
                isTwice = true;
            }
            catch (final Exception ex) {}
            if (isTwice) {
                if (StringUtil.isNotNull(redisSign) && Integer.valueOf(redisSign) == 0) {
                    return false;
                }
            }
            else if (StringUtil.isNotNull(redisSign) && !"false".equals(redisSign)) {
                return false;
            }
            final String signStr = String.valueOf(expires) + ":" + fdId;
            final ISysRestserviceServerMainService sysRestMainService = (ISysRestserviceServerMainService)SpringBeanUtil.getBean("sysRestserviceServerMainService");
            final SysRestserviceServerMain sysRestserviceServerMain = sysRestMainService.findByServiceBean("sysAttachmentRestService");
            final List<SysRestserviceServerPolicy> webPolicys = sysRestserviceServerMain.getFdPolicy();
            if (ArrayUtil.isEmpty((List)webPolicys)) {
                return false;
            }
            for (final SysRestserviceServerPolicy webPolicy : webPolicys) {
                final String calcSign = SignUtil.getHMAC(String.valueOf(signStr) + ":" + webPolicy.getFdLoginId(), StringUtil.isNotNull(webPolicy.getFdPassword()) ? webPolicy.getFdPassword() : webPolicy.getFdId());
                if (sign.equals(calcSign)) {
                    auth = true;
                    break;
                }
            }
        }
        if (auth) {
            if (isTwice) {
                if (StringUtil.isNotNull(redisSign)) {
                    int i = Integer.valueOf(redisSign);
                    if (i != 0) {
                        --i;
                        final Long time = Long.valueOf(expires) - System.currentTimeMillis();
                        if (time > 1000L) {
                            SysAttUtil.tokenCache.put(sign, (Object)String.valueOf(i), Integer.valueOf(time.intValue()));
                        }
                    }
                }
            }
            else if ("false".equals(redisSign)) {
                final Long time2 = Long.valueOf(expires) - System.currentTimeMillis();
                if (time2 > 1000L) {
                    SysAttUtil.tokenCache.put(sign, (Object)"true", Integer.valueOf(time2.intValue()));
                }
            }
        }
        return auth;
    }
    
    public void statistics(final HttpServletRequest request, final SysAttMainForm form) throws Exception {
        request.setAttribute("fdSize", (Object)SysAttViewerUtil.convertFileSize(Double.valueOf(form.getFdSize())));
        final String fdModelName = form.getFdModelName();
        final String fdModelId = form.getFdModelId();
        if (StringUtil.isNull(fdModelName)) {
            return;
        }
        request.setAttribute("fdModuleName", (Object)this.getMainModuleName(fdModelName));
        final String[] urlAndName = this.getMainUrlAndName(fdModelId, fdModelName);
        request.setAttribute("fdMainUrl", (Object)urlAndName[0]);
        if (StringUtil.isNull(urlAndName[1])) {
            return;
        }
        request.setAttribute("fdMainName", (Object)urlAndName[1]);
    }
    
    public String getMainModuleName(final String modelName) throws Exception {
        final SysDictModel dict = SysDataDict.getInstance().getModel(modelName);
        if (dict == null) {
            return null;
        }
        return ResourceUtil.getString(dict.getMessageKey());
    }
    
    public String[] getMainUrlAndName(final String modelId, final String modelName) throws Exception {
        final SysDictModel dict = SysDataDict.getInstance().getModel(modelName);
        if (dict == null) {
            return null;
        }
        String fdMainName = null;
        String fdUrl = null;
        try {
            final IBaseService service = (IBaseService)SpringBeanUtil.getBean(dict.getServiceBean());
            final IBaseModel baseModel = service.findByPrimaryKey(modelId);
            if (PropertyUtils.isReadable((Object)baseModel, "docSubject")) {
                fdMainName = PropertyUtils.getProperty((Object)baseModel, "docSubject").toString();
            }
            if (StringUtil.isNull(fdMainName) && PropertyUtils.isReadable((Object)baseModel, "fdName")) {
                fdMainName = PropertyUtils.getProperty((Object)baseModel, "fdName").toString();
            }
            fdUrl = ModelUtil.getModelUrl((Object)baseModel);
        }
        catch (final Exception e) {
            SysAttMainCoreInnerServiceImp.logger.error("获取主文档标题和链接报错：" + e);
        }
        return new String[] { fdUrl, fdMainName };
    }
    
    public String[] checkShare(final HttpServletRequest request) throws Exception {
        final String[] fdAttIds = request.getParameterValues("fdAttIds");
        if (ArrayUtils.isEmpty(fdAttIds)) {
            return null;
        }
        final List<String> ids = new ArrayList<String>();
        String[] array;
        for (int length = (array = fdAttIds).length, i = 0; i < length; ++i) {
            final String fdAttId = array[i];
            final Boolean auth = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=download&fdId=" + fdAttId, "get");
            if (auth) {
                ids.add(fdAttId);
            }
        }
        return ids.toArray(new String[0]);
    }
    
    public boolean updateRelation(final HttpServletRequest request) throws Exception {
        boolean flag = true;
        try {
            final String fdAttMainId = request.getParameter("fdAttMainId");
            final String fdModelId = request.getParameter("fdModelId");
            final String fdModelName = request.getParameter("fdModelName");
            final String fdKey = request.getParameter("fdKey");
            final SysAttMain sysAttMain = (SysAttMain)this.findByPrimaryKey(fdAttMainId);
            if (StringUtil.isNotNull(sysAttMain.getFdTempKey())) {
                sysAttMain.setFdTempKey("");
            }
            sysAttMain.setFdKey(fdKey);
            sysAttMain.setFdModelId(fdModelId);
            sysAttMain.setFdModelName(fdModelName);
            this.update((IBaseModel)sysAttMain);
        }
        catch (final Exception e) {
            e.printStackTrace();
            flag = false;
        }
        return flag;
    }
    
    public boolean updateCloudRelation(final HttpServletRequest request) throws Exception {
        boolean flag = true;
        try {
            final String fdAttMainId = request.getParameter("fdAttMainId");
            SysAttWpsCloudUtil.updateAttByMainId(fdAttMainId);
        }
        catch (final Exception e) {
            e.printStackTrace();
            flag = false;
        }
        return flag;
    }
    
    public SysAttMain addOnlineFile(final HttpServletRequest request) throws Exception {
        SysAttMain copyAtt = new SysAttMain();
        final String fdTemplateModelId = request.getParameter("fdTemplateModelId");
        final String fdTemplateModelName = request.getParameter("fdTemplateModelName");
        final String fdTemplateModelKey = request.getParameter("fdTemplateKey");
        final String fdTempKey = request.getParameter("fdTempKey");
        final String fdKey = request.getParameter("fdKey");
        final String fdModelId = request.getParameter("fdModelId");
        final String fdModelName = request.getParameter("fdModelName");
        final Object attObj = this.findFirstOne("sysAttMain.fdKey = '" + fdKey + "' and sysAttMain.fdModelId = '" + fdModelId + "' and sysAttMain.fdModelName='" + fdModelName + "'", "");
        final ISysAttMainCoreInnerService sysAttMainService = (ISysAttMainCoreInnerService)SpringBeanUtil.getBean("sysAttMainService");
        if (attObj == null) {
            InputStream in = null;
            try {
                if (StringUtil.isNotNull(fdTemplateModelId) && StringUtil.isNotNull(fdTemplateModelName) && StringUtil.isNotNull(fdTemplateModelKey)) {
                    final Object obj = this.findFirstOne("sysAttMain.fdKey = '" + fdTemplateModelKey + "' and sysAttMain.fdModelId = '" + fdTemplateModelId + "' and sysAttMain.fdModelName='" + fdTemplateModelName + "'", "");
                    if (obj != null) {
                        final SysAttMain tempAtt = (SysAttMain)obj;
                        in = this.getInputStream(tempAtt);
                    }
                }
                if (in == null) {
                    final File file = new File(String.valueOf(ConfigLocationsUtil.getWebContentPath()) + "/sys/attachment/templateFile/editOnlineTemplate.doc");
                    if (file.exists()) {
                        in = new FileInputStream(file);
                    }
                }
                copyAtt.setInputStream(in);
                copyAtt.setFdModelId(fdModelId);
                copyAtt.setFdModelName(fdModelName);
                copyAtt.setFdKey(fdKey);
                copyAtt.setFdTempKey(String.valueOf(fdTempKey) + "_online_create");
                final double fileSize = in.available();
                copyAtt.setFdSize(Double.valueOf(fileSize));
                copyAtt.setFdContentType("application/msword");
                copyAtt.setFdAttType("office");
                copyAtt.setFdFileName("editonline.doc");
                sysAttMainService.add((IBaseModel)copyAtt);
            }
            catch (final Exception e) {
                e.printStackTrace();
                return copyAtt;
            }
            finally {
                if (in != null) {
                    in.close();
                }
            }
            if (in != null) {
                in.close();
            }
        }
        else {
            copyAtt = (SysAttMain)attObj;
        }
        return copyAtt;
    }
    
    public SysAttMain addCloudOnlineFile(final HttpServletRequest request) throws Exception {
        if (SysAttMainCoreInnerServiceImp.logger.isDebugEnabled()) {
            SysAttMainCoreInnerServiceImp.logger.debug("复制附件处理：不存在附件流的情况。");
        }
        SysAttMain copyAtt = new SysAttMain();
        final String fdTemplateModelId = request.getParameter("fdTemplateModelId");
        final String fdTemplateModelName = request.getParameter("fdTemplateModelName");
        final String fdTemplateModelKey = request.getParameter("fdTemplateKey");
        final String fdKey = request.getParameter("fdKey");
        final String fdModelName = request.getParameter("fdModelName");
        final String fdModelId = request.getParameter("fdModelId");
        final String fdFileExt = request.getParameter("fdFileExt");
        final String isPrint = request.getParameter("isPrint");
        final Object attObj = this.findFirstOne("sysAttMain.fdKey = '" + fdKey + "' and sysAttMain.fdModelId = '" + fdModelId + "' and sysAttMain.fdModelName='" + fdModelName + "'", "");
        if (attObj == null) {
            InputStream in = null;
            if (StringUtil.isNotNull(fdTemplateModelId) && StringUtil.isNotNull(fdTemplateModelName) && StringUtil.isNotNull(fdTemplateModelKey)) {
                final Object obj = this.findFirstOne("sysAttMain.fdKey = '" + fdTemplateModelKey + "' and sysAttMain.fdModelId = '" + fdTemplateModelId + "' and sysAttMain.fdModelName='" + fdTemplateModelName + "'", "");
                if (obj != null) {
                    final SysAttMain tempAtt = (SysAttMain)obj;
                    final String fdDownLoadUrl = SysAttWpsCloudUtil.getWpsDownloadUrl(tempAtt.getFdId());
                    if (StringUtil.isNotNull(fdDownLoadUrl)) {
                        in = FileDowloadUtil.getFileInputStream(fdDownLoadUrl);
                    }
                    else {
                        in = this.getInputStream(tempAtt);
                    }
                }
            }
            if (in == null) {
                String templateFilePath = "/sys/attachment/templateFile/editOnlineTemplate.doc";
                if ("docx".equals(fdFileExt)) {
                    templateFilePath = "/sys/attachment/templateFile/editOnlineTemplate.docx";
                }
                if ("true".equals(isPrint)) {
                    templateFilePath = "/sys/attachment/templateFile/editOnlinePrint.docx";
                }
                final File file = new File(String.valueOf(ConfigLocationsUtil.getWebContentPath()) + templateFilePath);
                if (file.exists()) {
                    in = new FileInputStream(file);
                }
            }
            final ByteArrayOutputStream bao = new ByteArrayOutputStream();
            final byte[] buff = new byte[100];
            int rc = 0;
            while ((rc = in.read(buff, 0, 100)) > 0) {
                bao.write(buff, 0, rc);
            }
            final String appendStr = copyAtt.getFdId();
            final byte[] appendByte = appendStr.getBytes();
            bao.write(appendByte);
            final byte[] byt = bao.toByteArray();
            final InputStream newin = new ByteArrayInputStream(byt);
            copyAtt.setInputStream(newin);
            copyAtt.setFdModelId(fdModelId);
            copyAtt.setFdModelName(fdModelName);
            copyAtt.setFdKey(fdKey);
            final double fileSize = newin.available();
            copyAtt.setFdSize(Double.valueOf(fileSize));
            copyAtt.setFdAttType("office");
            if ("docx".equals(fdFileExt)) {
                copyAtt.setFdFileName("editonline.docx");
                copyAtt.setFdContentType("application/vnd.openxmlformats-officedocument.wordprocessingml.document");
            }
            else {
                copyAtt.setFdFileName("editonline.doc");
                copyAtt.setFdContentType("application/msword");
            }
            if ("true".equals(isPrint)) {
                copyAtt.setFdFileName("editOnlinePrint.docx");
            }
            final ISysAttMainCoreInnerService sysAttMainService = (ISysAttMainCoreInnerService)SpringBeanUtil.getBean("sysAttMainService");
            try {
                sysAttMainService.add((IBaseModel)copyAtt);
            }
            catch (final Exception e) {
                throw new RuntimeException(e);
            }
            finally {
                if (in != null) {
                    in.close();
                }
                if (newin != null) {
                    newin.close();
                }
            }
            if (in != null) {
                in.close();
            }
            if (newin != null) {
                newin.close();
            }
            SysAttWpsCloudUtil.syncAttToAddByMainId(copyAtt.getFdId());
        }
        else {
            copyAtt = (SysAttMain)attObj;
        }
        return copyAtt;
    }
    
    public JSONObject getWpsUrlAndToken(final HttpServletRequest request) throws Exception {
        final JSONObject json = new JSONObject();
        final String fdAttMainId = request.getParameter("fdAttMainId");
        if (fdAttMainId == null || fdAttMainId.isEmpty()) {
            return null;
        }
        final SysAttMain sysAttMain = (SysAttMain)this.findByPrimaryKey(fdAttMainId);
        if (sysAttMain == null) {
            return null;
        }
        final String fdMode = request.getParameter("fdMode");
        final String fdKey = sysAttMain.getFdKey();
        final String fdModelId = sysAttMain.getFdModelId();
        final String fdModelName = sysAttMain.getFdModelName();
        final String filename = sysAttMain.getFdFileName();
        final String fileExt = filename.substring(filename.lastIndexOf(".") + 1, filename.length());
        final long expires = System.currentTimeMillis() + 14400000L;
        String wpsUrl = String.valueOf(SysAttWpsWebOfficeUtil.getUrl()) + "/office";
        if (WpsUtil.isExcel(fileExt)) {
            wpsUrl = String.valueOf(wpsUrl) + "/s/";
        }
        else if (WpsUtil.isPpt(fileExt)) {
            wpsUrl = String.valueOf(wpsUrl) + "/p/";
        }
        else if (WpsUtil.isPdf(fileExt)) {
            wpsUrl = String.valueOf(wpsUrl) + "/f/";
        }
        else {
            wpsUrl = String.valueOf(wpsUrl) + "/w/";
        }
        wpsUrl = String.valueOf(wpsUrl) + fdAttMainId + "?";
        String params = "_w_appid=" + SysAttWpsWebOfficeUtil.getAppid() + "&_w_tokentype=1&_w_fdMode=" + fdMode + "&_w_fileId=" + fdAttMainId + "&_w_fdKey=" + fdKey;
        if (StringUtil.isNotNull(fdModelId)) {
            params = String.valueOf(params) + "&_w_fdModelId=" + fdModelId;
        }
        if (StringUtil.isNotNull(fdModelName)) {
            params = String.valueOf(params) + "&_w_fdModelName=" + fdModelName;
        }
        final net.sf.json.JSONObject watermarkCfg = SysAttViewerUtil.getWaterMarkConfigInDB(Boolean.valueOf(true));
        if (watermarkCfg.get("markWordVar") != null) {
            final String markWord = SysAttViewerUtil.getVarMarkWord(watermarkCfg.getString("markWordVar"), request);
            boolean isAvailable = UserUtil.getKMSSUser().getUserAuthInfo().getAuthRoleAliases().contains("ROLE_SYSATTACHMENT_REMOVE_WATERMARK");
            if (UserUtil.getKMSSUser().isAdmin()) {
                isAvailable = false;
            }
            if (!isAvailable && StringUtil.isNotNull(markWord)) {
                params = String.valueOf(params) + "&_w_markWord=" + markWord;
            }
        }
        params = String.valueOf(params) + "&_w_userid=" + UserUtil.getUser().getFdId() + "&_w_username=" + UserUtil.getUser().getFdName() + "&_w_Expires=" + expires;
        final String signature = WpsUtil.getSignature(WpsUtil.paramToMap(params), SysAttWpsWebOfficeUtil.getAppkey());
        wpsUrl = String.valueOf(wpsUrl) + params + "&_w_signature=" + signature;
        json.put((Object)"wpsUrl", (Object)wpsUrl);
        final String token = this.getRestSign(fdAttMainId, expires);
        json.put((Object)"token", (Object)token);
        return json;
    }
    
    private String getRestSign(final String attMainId, final long expires) throws Exception {
        final String signStr = String.valueOf(expires) + ":" + attMainId;
        final ISysRestserviceServerMainService sysRestMainService = (ISysRestserviceServerMainService)SpringBeanUtil.getBean("sysRestserviceServerMainService");
        final SysRestserviceServerMain sysRestserviceServerMain = sysRestMainService.findByServiceBean("sysAttachmentRestService");
        if (sysRestserviceServerMain == null) {
            return "";
        }
        final List<SysRestserviceServerPolicy> webPolicys = sysRestserviceServerMain.getFdPolicy();
        if (ArrayUtil.isEmpty((List)webPolicys)) {
            return "";
        }
        final SysRestserviceServerPolicy webPolicy = webPolicys.get(0);
        final String sign = SignUtil.getHMAC(String.valueOf(signStr) + ":" + webPolicy.getFdLoginId(), StringUtil.isNotNull(webPolicy.getFdPassword()) ? webPolicy.getFdPassword() : webPolicy.getFdId());
        return sign;
    }
    
    public String getRestDownloadUrl(final String fdId) throws Exception {
        return this.getRestDownload(fdId, null);
    }
    
    public String getRestDownloadUrl(final String fdId, final String modelName) throws Exception {
        return this.getRestDownload(fdId, modelName);
    }
    
    private String getRestDownload(final String fdId, final String modelName) {
        try {
            final HQLInfo hqlInfo = new HQLInfo();
            hqlInfo.setWhereBlock("fdId=:fdId");
            hqlInfo.setParameter("fdId", (Object)fdId);
            final Object obj = this.findFirstOne(hqlInfo);
            final SysAttMain attMain = (SysAttMain)obj;
            final SysAttFile file = this.sysAttUploadService.getFileById(attMain.getFdFileId());
            final ISysFileLocationDirectService directService = SysFileLocationUtil.getDirectService(file.getFdAttLocation());
            final boolean isSupportDirect = directService.isSupportDirect("");
            if (isSupportDirect) {
                return directService.getDownloadUrl(file.getFdFilePath(), attMain.getFdFileName());
            }
            final long expires = System.currentTimeMillis() + 180000L;
            String url = ResourceUtil.getKmssConfigString("kmss.urlPrefix");
            final String sign = this.getRestSign(fdId, expires);
            if (StringUtil.isNotNull(modelName)) {
                url = String.valueOf(url.toLowerCase()) + "/sys/attachment/sys_att_main/downloadFile.jsp?fdId=" + fdId + "&Expires=" + expires + "&Signature=" + sign + "&reqType=rest&wpsExtAppModel=" + modelName + "&filename=" + URLEncoder.encode(attMain.getFdFileName(), "utf-8");
            }
            else {
                url = String.valueOf(url.toLowerCase()) + "/sys/attachment/sys_att_main/downloadFile.jsp?fdId=" + fdId + "&Expires=" + expires + "&Signature=" + sign + "&reqType=rest&filename=" + URLEncoder.encode(attMain.getFdFileName(), "utf-8");
            }
            return url;
        }
        catch (final Exception e) {
            SysAttMainCoreInnerServiceImp.logger.error("", e.getCause());
            e.printStackTrace();
            return null;
        }
    }
    
    public List<SysAttMain> cloneDocAtts(final JSONArray attsInfo) throws Exception {
        final List<SysAttMain> atts = new ArrayList<SysAttMain>();
        for (int i = 0; i < attsInfo.size(); ++i) {
            final net.sf.json.JSONObject obj = attsInfo.getJSONObject(i);
            final String exsitAttIds = obj.optString("exsitAttIds");
            final String newKey = obj.optString("newKey");
            final String fdModelId = obj.optString("fdModelId");
            final String fdModelName = obj.optString("fdModelName");
            final String oldKey = obj.optString("oldKey");
            final String curModelName = obj.optString("curModelName");
            List<SysAttMain> exsitList = new ArrayList<SysAttMain>();
            final Map<String, SysAttMain> exsitAtt = new HashMap<String, SysAttMain>();
            if (StringUtil.isNotNull(exsitAttIds)) {
                final String[] ids = exsitAttIds.split("[;；]");
                exsitList = this.getSysAttMainDao().findByPrimaryKeys(ids);
                for (final SysAttMain att : exsitList) {
                    exsitAtt.put(att.getFdFileId(), att);
                }
            }
            final List<SysAttMain> tempList = this.getSysAttMainDao().findByModelKey(fdModelName, fdModelId, oldKey);
            for (final SysAttMain att : tempList) {
                if (exsitList.size() > 0 && exsitAtt.containsKey(att.getFdFileId())) {
                    atts.add(exsitAtt.get(att.getFdFileId()));
                }
                else {
                    final SysAttMain copyAtt = (SysAttMain)att.clone();
                    copyAtt.setFdId(IDGenerator.generateID());
                    copyAtt.setFdCreatorId(UserUtil.getUser().getFdId());
                    copyAtt.setDocCreateTime(new Date());
                    copyAtt.setFdModelId("");
                    copyAtt.setFdModelName(curModelName);
                    copyAtt.setDownloadSum(Integer.valueOf(0));
                    copyAtt.setFdBorrowCount(new Long(0L));
                    copyAtt.setFdOrder((Integer)null);
                    copyAtt.setFdLastOpenTime((Date)null);
                    copyAtt.setFdKey(newKey);
                    this.getSysAttMainDao().add((IBaseModel)copyAtt);
                    atts.add(copyAtt);
                }
            }
        }
        return atts;
    }
    
    public String downloadPluginXml(final String realPath) throws Exception {
        final String xmlFile = String.valueOf(realPath) + "/sys/attachment/sys_att_main/wps/oaassist/xml/jsplugins.xml";
        String xml = FileUtil.getFileString(xmlFile, "UTF-8");
        xml = xml.replaceAll("\\$\\{sys.attmain.wps.oaassit.hostPortAndAppName\\}", ResourceUtil.getKmssConfigString("kmss.urlPrefix"));
        return xml;
    }
    
    public SysAttMain addWpsOaassistOnlineFile(final HttpServletRequest request) throws Exception {
        new SysAttMain();
        final String fdTemplateModelId = request.getParameter("fdTemplateModelId");
        final String fdTemplateModelName = request.getParameter("fdTemplateModelName");
        final String fdTemplateModelKey = request.getParameter("fdTemplateKey");
        final String fdKey = request.getParameter("fdKey");
        final String fdModelName = request.getParameter("fdModelName");
        final String fdModelId = request.getParameter("fdModelId");
        return this.addWpsOaassistOnlineFile(fdTemplateModelId, fdTemplateModelName, fdTemplateModelKey, fdKey, fdModelName, fdModelId);
    }
    
    public SysAttMain addWpsOaassistOnlineFile(final String fdTemplateModelId, final String fdTemplateModelName, final String fdTemplateModelKey, final String fdKey, final String fdModelName, final String fdModelId) throws Exception {
        SysAttMain copyAtt = new SysAttMain();
        final Object attObj = this.findFirstOne("sysAttMain.fdKey = '" + fdKey + "' and sysAttMain.fdModelId = '" + fdModelId + "' and sysAttMain.fdModelName='" + fdModelName + "'", "");
        if (attObj == null) {
            InputStream in = null;
            if (StringUtil.isNotNull(fdTemplateModelId) && StringUtil.isNotNull(fdTemplateModelName) && StringUtil.isNotNull(fdTemplateModelKey)) {
                final Object obj = this.findFirstOne("sysAttMain.fdKey = '" + fdTemplateModelKey + "' and sysAttMain.fdModelId = '" + fdTemplateModelId + "' and sysAttMain.fdModelName='" + fdTemplateModelName + "'", "");
                if (obj != null) {
                    final SysAttMain tempAtt = (SysAttMain)obj;
                    in = this.getInputStream(tempAtt);
                }
            }
            if (in == null) {
                final String templateFilePath = "/sys/attachment/templateFile/editOnlineTemplate.docx";
                final File file = new File(String.valueOf(ConfigLocationsUtil.getWebContentPath()) + templateFilePath);
                if (file.exists()) {
                    in = new FileInputStream(file);
                }
            }
            final ByteArrayOutputStream bao = new ByteArrayOutputStream();
            final byte[] buff = new byte[100];
            int rc = 0;
            while ((rc = in.read(buff, 0, 100)) > 0) {
                bao.write(buff, 0, rc);
            }
            final String appendStr = copyAtt.getFdId();
            final byte[] appendByte = appendStr.getBytes();
            bao.write(appendByte);
            final byte[] byt = bao.toByteArray();
            final InputStream newin = new ByteArrayInputStream(byt);
            copyAtt.setInputStream(newin);
            copyAtt.setFdModelId(fdModelId);
            copyAtt.setFdModelName(fdModelName);
            copyAtt.setFdKey(fdKey);
            final double fileSize = newin.available();
            copyAtt.setFdSize(Double.valueOf(fileSize));
            copyAtt.setFdAttType("office");
            copyAtt.setFdFileName("editonline.docx");
            copyAtt.setFdContentType("application/vnd.openxmlformats-officedocument.wordprocessingml.document");
            final ISysAttMainCoreInnerService sysAttMainService = (ISysAttMainCoreInnerService)SpringBeanUtil.getBean("sysAttMainService");
            try {
                sysAttMainService.add((IBaseModel)copyAtt);
            }
            catch (final Exception e) {
                throw new RuntimeException(e);
            }
            finally {
                if (in != null) {
                    in.close();
                }
                if (newin != null) {
                    newin.close();
                }
            }
            if (in != null) {
                in.close();
            }
            if (newin != null) {
                newin.close();
            }
        }
        else {
            copyAtt = (SysAttMain)attObj;
        }
        return copyAtt;
    }
    
    public SysAttMain addWpsOaassistOnlineFile(final SysAttMain sam) throws Exception {
        final String fdTemplateModelId = sam.getFdModelId();
        final String fdTemplateModelName = sam.getFdModelName();
        final String fdTemplateModelKey = sam.getFdKey();
        final String fdKey = sam.getFdKey();
        final String fdModelName = sam.getFdModelName();
        final String fdModelId = sam.getFdModelId();
        final String fdFileName = sam.getFdFileName();
        SysAttMain copyAtt = new SysAttMain();
        final Object attObj = this.findFirstOne("sysAttMain.fdKey = '" + fdKey + "' and sysAttMain.fdModelId = '" + fdModelId + "' and sysAttMain.fdModelName='" + fdModelName + "'", "");
        if (attObj == null) {
            InputStream in = null;
            if (StringUtil.isNotNull(fdTemplateModelId) && StringUtil.isNotNull(fdTemplateModelName) && StringUtil.isNotNull(fdTemplateModelKey)) {
                final Object obj = this.findFirstOne("sysAttMain.fdKey = '" + fdTemplateModelKey + "' and sysAttMain.fdModelId = '" + fdTemplateModelId + "' and sysAttMain.fdModelName='" + fdTemplateModelName + "'", "");
                if (obj != null) {
                    final SysAttMain tempAtt = (SysAttMain)obj;
                    in = this.getInputStream(tempAtt);
                }
            }
            if (in == null) {
                final String templateFilePath = "/sys/attachment/templateFile/editOnlineTemplate.docx";
                final File file = new File(String.valueOf(ConfigLocationsUtil.getWebContentPath()) + templateFilePath);
                if (file.exists()) {
                    in = new FileInputStream(file);
                }
            }
            final ByteArrayOutputStream bao = new ByteArrayOutputStream();
            final byte[] buff = new byte[100];
            int rc = 0;
            while ((rc = in.read(buff, 0, 100)) > 0) {
                bao.write(buff, 0, rc);
            }
            final String appendStr = copyAtt.getFdId();
            final byte[] appendByte = appendStr.getBytes();
            bao.write(appendByte);
            final byte[] byt = bao.toByteArray();
            final InputStream newin = new ByteArrayInputStream(byt);
            copyAtt.setInputStream(newin);
            copyAtt.setFdModelId(fdModelId);
            copyAtt.setFdModelName(fdModelName);
            copyAtt.setFdKey(fdKey);
            final double fileSize = newin.available();
            copyAtt.setFdSize(Double.valueOf(fileSize));
            copyAtt.setFdAttType("office");
            copyAtt.setFdFileName(String.valueOf(fdFileName) + ".docx");
            copyAtt.setFdContentType("application/vnd.openxmlformats-officedocument.wordprocessingml.document");
            final ISysAttMainCoreInnerService sysAttMainService = (ISysAttMainCoreInnerService)SpringBeanUtil.getBean("sysAttMainService");
            try {
                sysAttMainService.add((IBaseModel)copyAtt);
            }
            catch (final Exception e) {
                throw new RuntimeException(e);
            }
            finally {
                if (in != null) {
                    in.close();
                }
                if (newin != null) {
                    newin.close();
                }
            }
            if (in != null) {
                in.close();
            }
            if (newin != null) {
                newin.close();
            }
        }
        else {
            copyAtt = (SysAttMain)attObj;
        }
        return copyAtt;
    }
    
    public SysAttMain addJgOnlineFile(final SysAttMain sam, final HttpServletRequest request) throws Exception {
        final String fdTemplateModelId = sam.getFdModelId();
        final String fdTemplateModelName = sam.getFdModelName();
        final String fdTemplateModelKey = sam.getFdKey();
        final String fdKey = sam.getFdKey();
        final String fdModelName = sam.getFdModelName();
        final String fdModelId = sam.getFdModelId();
        final String fdFileName = sam.getFdFileName();
        SysAttMain copyAtt = new SysAttMain();
        final Object attObj = this.findFirstOne("sysAttMain.fdKey = '" + fdKey + "' and sysAttMain.fdModelId = '" + fdModelId + "' and sysAttMain.fdModelName='" + fdModelName + "'", "");
        if (attObj == null) {
            String fileExtName = null;
            InputStream in = null;
            if (StringUtil.isNotNull(fdTemplateModelId) && StringUtil.isNotNull(fdTemplateModelName) && StringUtil.isNotNull(fdTemplateModelKey)) {
                final Object obj = this.findFirstOne("sysAttMain.fdKey = '" + fdTemplateModelKey + "' and sysAttMain.fdModelId = '" + fdTemplateModelId + "' and sysAttMain.fdModelName='" + fdTemplateModelName + "'", "");
                if (obj != null) {
                    final SysAttMain tempAtt = (SysAttMain)obj;
                    in = this.getInputStream(tempAtt);
                    fileExtName = FilenameUtils.getExtension(tempAtt.getFdFileName());
                }
            }
            if (in == null) {
                fileExtName = "docx";
                final String templateFilePath = "/sys/attachment/templateFile/editOnlineTemplate.docx";
                final File file = new File(String.valueOf(ConfigLocationsUtil.getWebContentPath()) + templateFilePath);
                if (file.exists()) {
                    in = new FileInputStream(file);
                }
            }
            final ByteArrayOutputStream bao = new ByteArrayOutputStream();
            final byte[] buff = new byte[100];
            int rc = 0;
            while ((rc = in.read(buff, 0, 100)) > 0) {
                bao.write(buff, 0, rc);
            }
            final byte[] byt = bao.toByteArray();
            final InputStream newin = new ByteArrayInputStream(byt);
            copyAtt.setInputStream(newin);
            copyAtt.setFdModelId(fdModelId);
            copyAtt.setFdModelName(fdModelName);
            copyAtt.setFdKey(fdKey);
            final double fileSize = newin.available();
            copyAtt.setFdSize(Double.valueOf(fileSize));
            copyAtt.setFdAttType("office");
            if ("docx".equals(fileExtName)) {
                copyAtt.setFdFileName(String.valueOf(fdFileName) + ".docx");
                copyAtt.setFdContentType("application/vnd.openxmlformats-officedocument.wordprocessingml.document");
            }
            else {
                copyAtt.setFdFileName(String.valueOf(fdFileName) + ".doc");
                copyAtt.setFdContentType("application/msword");
            }
            final ISysAttMainCoreInnerService sysAttMainService = (ISysAttMainCoreInnerService)SpringBeanUtil.getBean("sysAttMainService");
            try {
                sysAttMainService.add((IBaseModel)copyAtt, Boolean.valueOf(false), Boolean.valueOf(false));
            }
            catch (final Exception e) {
                throw new RuntimeException(e);
            }
            finally {
                if (in != null) {
                    in.close();
                }
                if (newin != null) {
                    newin.close();
                }
            }
            if (in != null) {
                in.close();
            }
            if (newin != null) {
                newin.close();
            }
        }
        else {
            copyAtt = (SysAttMain)attObj;
        }
        return copyAtt;
    }
    
    public SysAttMain setWpsOnlineFile(final SysAttMain sam, final String modelId, final String modelName) throws Exception {
        final String fdKey = sam.getFdKey();
        final String fdModelName = sam.getFdModelName();
        final String fdModelId = sam.getFdModelId();
        final String fdFileName = sam.getFdFileName();
        InputStream in = null;
        InputStream newin = null;
        final SysAttMain copyAtt = new SysAttMain();
        SysAttMain sysAttMain = null;
        final Object obj = this.findFirstOne("sysAttMain.fdKey = '" + fdKey + "' and sysAttMain.fdModelId = '" + fdModelId + "' and sysAttMain.fdModelName='" + fdModelName + "'", "");
        try {
            if (obj != null) {
                sysAttMain = (SysAttMain)obj;
                in = this.getInputStream(sysAttMain);
            }
            else {
                final String templateFilePath = "/sys/attachment/templateFile/editOnlineTemplate.docx";
                final File file = new File(String.valueOf(ConfigLocationsUtil.getWebContentPath()) + templateFilePath);
                if (file.exists()) {
                    in = new FileInputStream(file);
                }
            }
            if (in == null) {
                final String templateFilePath = "/sys/attachment/templateFile/editOnlineTemplate.docx";
                final File file = new File(String.valueOf(ConfigLocationsUtil.getWebContentPath()) + templateFilePath);
                if (file.exists()) {
                    in = new FileInputStream(file);
                }
            }
            final ByteArrayOutputStream bao = new ByteArrayOutputStream();
            final byte[] buff = new byte[100];
            int rc = 0;
            while ((rc = in.read(buff, 0, 100)) > 0) {
                bao.write(buff, 0, rc);
            }
            final String appendStr = copyAtt.getFdId();
            final byte[] appendByte = appendStr.getBytes();
            bao.write(appendByte);
            final byte[] byt = bao.toByteArray();
            newin = new ByteArrayInputStream(byt);
            copyAtt.setInputStream(newin);
            copyAtt.setFdModelId(modelId);
            copyAtt.setFdModelName(modelName);
            copyAtt.setFdCreatorId(UserUtil.getUser().getFdId());
            copyAtt.setDocCreateTime(new Date());
            copyAtt.setFdKey(fdKey);
            final double fileSize = newin.available();
            copyAtt.setFdSize(Double.valueOf(fileSize));
            copyAtt.setFdAttType("office");
            if (sysAttMain != null) {
                copyAtt.setFdFileName(sysAttMain.getFdFileName());
            }
            else {
                copyAtt.setFdFileName(String.valueOf(fdFileName) + ".docx");
            }
            copyAtt.setFdContentType("application/vnd.openxmlformats-officedocument.wordprocessingml.document");
        }
        catch (final Exception e) {
            throw new RuntimeException(e);
        }
        finally {
            if (in != null) {
                in.close();
            }
            if (newin != null) {
                newin.close();
            }
        }
        if (in != null) {
            in.close();
        }
        if (newin != null) {
            newin.close();
        }
        return copyAtt;
    }
    
    public SysAttMain setJgOnlineFile(final SysAttMain sam, final String modelId, final String modelName, final HttpServletRequest request) throws Exception {
        final String fdKey = sam.getFdKey();
        final String fdModelName = sam.getFdModelName();
        final String fdModelId = sam.getFdModelId();
        final String fdFileName = sam.getFdFileName();
        InputStream in = null;
        InputStream newin = null;
        final SysAttMain copyAtt = new SysAttMain();
        SysAttMain sysAttMain = null;
        final Object obj = this.findFirstOne("sysAttMain.fdKey = '" + fdKey + "' and sysAttMain.fdModelId = '" + fdModelId + "' and sysAttMain.fdModelName='" + fdModelName + "'", "");
        String fileExtName = null;
        try {
            if (obj != null) {
                sysAttMain = (SysAttMain)obj;
                in = this.getInputStream(sysAttMain);
                fileExtName = FilenameUtils.getExtension(sysAttMain.getFdFileName());
            }
            else {
                fileExtName = "docx";
                final String templateFilePath = "/sys/attachment/templateFile/editOnlineTemplate.docx";
                final File file = new File(String.valueOf(ConfigLocationsUtil.getWebContentPath()) + templateFilePath);
                if (file.exists()) {
                    in = new FileInputStream(file);
                }
            }
            if (in == null) {
                fileExtName = "docx";
                final String templateFilePath = "/sys/attachment/templateFile/editOnlineTemplate.docx";
                final File file = new File(String.valueOf(ConfigLocationsUtil.getWebContentPath()) + templateFilePath);
                if (file.exists()) {
                    in = new FileInputStream(file);
                }
            }
            final ByteArrayOutputStream bao = new ByteArrayOutputStream();
            final byte[] buff = new byte[100];
            int rc = 0;
            while ((rc = in.read(buff, 0, 100)) > 0) {
                bao.write(buff, 0, rc);
            }
            final byte[] byt = bao.toByteArray();
            newin = new ByteArrayInputStream(byt);
            copyAtt.setInputStream(newin);
            copyAtt.setFdModelId(modelId);
            copyAtt.setFdModelName(modelName);
            copyAtt.setFdCreatorId(UserUtil.getUser().getFdId());
            copyAtt.setDocCreateTime(new Date());
            copyAtt.setFdKey(fdKey);
            final double fileSize = newin.available();
            copyAtt.setFdSize(Double.valueOf(fileSize));
            copyAtt.setFdAttType("office");
            if (sysAttMain != null) {
                copyAtt.setFdFileName(sysAttMain.getFdFileName());
                copyAtt.setFdContentType(sysAttMain.getFdContentType());
            }
            else if ("docx".equals(fileExtName)) {
                copyAtt.setFdFileName(String.valueOf(fdFileName) + ".docx");
                copyAtt.setFdContentType("application/vnd.openxmlformats-officedocument.wordprocessingml.document");
            }
            else {
                copyAtt.setFdFileName(String.valueOf(fdFileName) + ".doc");
                copyAtt.setFdContentType("application/msword");
            }
        }
        catch (final Exception e) {
            throw new RuntimeException(e);
        }
        finally {
            if (in != null) {
                in.close();
            }
            if (newin != null) {
                newin.close();
            }
        }
        if (in != null) {
            in.close();
        }
        if (newin != null) {
            newin.close();
        }
        return copyAtt;
    }
    
    public boolean updateDelRelation(final String fdAttMainId) throws Exception {
        boolean flag = true;
        try {
            final SysAttMain sysAttMain = (SysAttMain)this.findByPrimaryKey(fdAttMainId);
            if (!sysAttMain.getFdCreatorId().equals(UserUtil.getKMSSUser().getUserId())) {
                return false;
            }
            sysAttMain.setFdModelId("");
            sysAttMain.setFdModelName("");
            this.getSysAttMainDao().update((IBaseModel)sysAttMain);
        }
        catch (final Exception e) {
            e.printStackTrace();
            flag = false;
        }
        return flag;
    }
    
    public SysAttMain addWpsCenterOnlineFile(final HttpServletRequest request) throws Exception {
        if (SysAttMainCoreInnerServiceImp.logger.isDebugEnabled()) {
            SysAttMainCoreInnerServiceImp.logger.debug("复制附件处理：不存在附件流的情况。");
        }
        SysAttMain copyAtt = new SysAttMain();
        final String fdTemplateModelId = request.getParameter("fdTemplateModelId");
        final String fdTemplateModelName = request.getParameter("fdTemplateModelName");
        final String fdTemplateModelKey = request.getParameter("fdTemplateKey");
        final String fdKey = request.getParameter("fdKey");
        final String fdModelName = request.getParameter("fdModelName");
        final String fdModelId = request.getParameter("fdModelId");
        String fdFileExt = request.getParameter("fdFileExt");
        final String isPrint = request.getParameter("isPrint");
        final String whereBlock = "sysAttMain.fdKey = :fdKey and sysAttMain.fdModelId = :fdModelId and sysAttMain.fdModelName = :fdModelName ";
        final HQLInfo hqlInfo = new HQLInfo();
        hqlInfo.setWhereBlock(whereBlock);
        hqlInfo.setParameter("fdKey", (Object)fdKey);
        hqlInfo.setParameter("fdModelId", (Object)fdModelId);
        hqlInfo.setParameter("fdModelName", (Object)fdModelName);
        final Object attObj = this.findFirstOne(hqlInfo);
        if (attObj == null) {
            String fileExtName = "";
            InputStream in = null;
            if (StringUtil.isNotNull(fdTemplateModelId) && StringUtil.isNotNull(fdTemplateModelName) && StringUtil.isNotNull(fdTemplateModelKey)) {
                final String block = "sysAttMain.fdKey = :fdTemplateModelKey and sysAttMain.fdModelId = :fdTemplateModelId and sysAttMain.fdModelName = :fdTemplateModelName";
                final HQLInfo hql = new HQLInfo();
                hql.setWhereBlock(block);
                hql.setParameter("fdTemplateModelKey", (Object)fdTemplateModelKey);
                hql.setParameter("fdTemplateModelId", (Object)fdTemplateModelId);
                hql.setParameter("fdTemplateModelName", (Object)fdTemplateModelName);
                final Object obj = this.findFirstOne(hql);
                if (obj != null) {
                    final SysAttMain tempAtt = (SysAttMain)obj;
                    in = this.getInputStream(tempAtt);
                    fileExtName = FilenameUtils.getExtension(tempAtt.getFdFileName());
                }
            }
            if (in == null) {
                String templateFilePath = "/sys/attachment/templateFile/";
                Label_0692: {
                    final String s;
                    switch (s = fdFileExt) {
                        case "doc": {
                            templateFilePath = String.valueOf(templateFilePath) + "editOnlineTemplate.doc";
                            break Label_0692;
                        }
                        case "ppt": {
                            templateFilePath = String.valueOf(templateFilePath) + "editOnlineTemplate.ppt";
                            break Label_0692;
                        }
                        case "xls": {
                            templateFilePath = String.valueOf(templateFilePath) + "editOnlineTemplate.xls";
                            break Label_0692;
                        }
                        case "docx": {
                            templateFilePath = String.valueOf(templateFilePath) + "editOnlineTemplate.docx";
                            break Label_0692;
                        }
                        case "pptx": {
                            templateFilePath = String.valueOf(templateFilePath) + "editOnlineTemplate.pptx";
                            break Label_0692;
                        }
                        case "xlsx": {
                            templateFilePath = String.valueOf(templateFilePath) + "editOnlineTemplate.xlsx";
                            break Label_0692;
                        }
                        case "print": {
                            templateFilePath = String.valueOf(templateFilePath) + "editOnlinePrint.doc";
                            break Label_0692;
                        }
                        default:
                            break;
                    }
                    fdFileExt = "docx";
                    templateFilePath = String.valueOf(templateFilePath) + "editOnlineTemplate.docx";
                }
                if ("true".equals(isPrint)) {
                    templateFilePath = "/sys/attachment/templateFile/editOnlinePrint.docx";
                }
                final File file = new File(String.valueOf(ConfigLocationsUtil.getWebContentPath()) + templateFilePath);
                if (file.exists()) {
                    in = new FileInputStream(file);
                }
                fileExtName = fdFileExt;
            }
            final ByteArrayOutputStream bao = new ByteArrayOutputStream();
            final byte[] buff = new byte[100];
            int rc = 0;
            while ((rc = in.read(buff, 0, 100)) > 0) {
                bao.write(buff, 0, rc);
            }
            if (!"0".equals(SysAttConfigUtil.getOnlineToolType())) {
                final String appendStr = copyAtt.getFdId();
                final byte[] appendByte = appendStr.getBytes();
                bao.write(appendByte);
            }
            final byte[] byt = bao.toByteArray();
            final InputStream newin = new ByteArrayInputStream(byt);
            copyAtt.setInputStream(newin);
            copyAtt.setFdModelId(fdModelId);
            copyAtt.setFdModelName(fdModelName);
            copyAtt.setFdKey(fdKey);
            final double fileSize = newin.available();
            copyAtt.setFdSize(Double.valueOf(fileSize));
            copyAtt.setFdAttType("office");
            Label_1172: {
                final String s2;
                switch (s2 = fileExtName) {
                    case "doc": {
                        copyAtt.setFdFileName("editonline.doc");
                        copyAtt.setFdContentType("application/msword");
                        break Label_1172;
                    }
                    case "ppt": {
                        copyAtt.setFdFileName("editonline.ppt");
                        copyAtt.setFdContentType("application/vnd.ms-powerpoint");
                        break Label_1172;
                    }
                    case "xls": {
                        copyAtt.setFdFileName("editonline.xls");
                        copyAtt.setFdContentType("application/vnd.ms-excel");
                        break Label_1172;
                    }
                    case "docx": {
                        copyAtt.setFdFileName("editonline.docx");
                        copyAtt.setFdContentType("application/vnd.openxmlformats-officedocument.wordprocessingml.document");
                        break Label_1172;
                    }
                    case "pptx": {
                        copyAtt.setFdFileName("editonline.pptx");
                        copyAtt.setFdContentType("application/vnd.openxmlformats-officedocument.presentationml.presentation");
                        break Label_1172;
                    }
                    case "xlsx": {
                        copyAtt.setFdFileName("editonline.xlsx");
                        copyAtt.setFdContentType("application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
                        break Label_1172;
                    }
                    default:
                        break;
                }
                copyAtt.setFdFileName("editonline.docx");
                copyAtt.setFdContentType("application/vnd.openxmlformats-officedocument.wordprocessingml.document");
            }
            if ("true".equals(isPrint)) {
                copyAtt.setFdFileName("editOnlinePrint.docx");
            }
            final ISysAttMainCoreInnerService sysAttMainService = (ISysAttMainCoreInnerService)SpringBeanUtil.getBean("sysAttMainService");
            try {
                if ("0".equals(SysAttConfigUtil.getOnlineToolType())) {
                    sysAttMainService.add((IBaseModel)copyAtt, Boolean.valueOf(false), Boolean.valueOf(false));
                }
                else {
                    sysAttMainService.add((IBaseModel)copyAtt);
                }
            }
            catch (final Exception e) {
                throw new RuntimeException(e);
            }
            finally {
                if (in != null) {
                    in.close();
                }
                if (newin != null) {
                    newin.close();
                }
            }
            if (in != null) {
                in.close();
            }
            if (newin != null) {
                newin.close();
            }
        }
        else {
            copyAtt = (SysAttMain)attObj;
        }
        return copyAtt;
    }
    
    public InputStream readAttachment(final String sysAttFileId) throws Exception {
        final SysAttFile sysAttFile = this.sysAttUploadService.getFileById(sysAttFileId);
        return this.readAttachment(sysAttFile);
    }
    
    public InputStream readAttachment(final SysAttFile sysAttFile) throws Exception {
        final String pathPrefix = (sysAttFile.getFdCata() == null) ? null : sysAttFile.getFdCata().getFdPath();
        final InputStream inputStream = SysFileLocationUtil.getProxyService(sysAttFile.getFdAttLocation()).readFile(sysAttFile.getFdFilePath(), pathPrefix);
        return inputStream;
    }
    
    public void writeAttachment(final InputStream inputStream, final SysAttFile sysAttFile) throws Exception {
        this.writeAttachment(inputStream, sysAttFile.getFdFilePath());
    }
    
    public void writeAttachment(final InputStream inputStream, final String filePath) throws Exception {
        SysFileLocationUtil.getProxyService().writeFile(inputStream, filePath);
    }
    
    public void updateByTmpAttmainId(final String editonlineFdId, final String editonlineTmpFdId) throws Exception {
        if (StringUtil.isNotNull(editonlineFdId) && StringUtil.isNotNull(editonlineTmpFdId)) {
            final SysAttMain sysAttMain = (SysAttMain)this.findByPrimaryKey(editonlineFdId);
            sysAttMain.setInputStream(this.getInputStream(editonlineTmpFdId));
            this.updateByUser((IBaseModel)sysAttMain, UserUtil.getUser().getFdId());
        }
    }
    
    public com.alibaba.fastjson.JSONObject addQueneByURL(final AddQueneParameter parameter) throws Exception {
        final com.alibaba.fastjson.JSONObject object = new com.alibaba.fastjson.JSONObject();
        if (parameter.getModel() == null || StringUtil.isNull(parameter.getConverterType()) || StringUtil.isNull(parameter.getConverterKey()) || StringUtil.isNull(parameter.getModelAttKey()) || StringUtil.isNull(parameter.getConverterUrl())) {
            object.put("status", (Object)"failure");
            object.put("info", (Object)"转换参数不符合要求!");
        }
        else {
            try {
                if (SysFileStoreUtil.isChosenConvertServer(parameter.getConverterType())) {
                    final HtmlToMht htmlToMht = new HtmlToMht(false);
                    final String serverUrl = ResourceUtil.getKmssConfigString("kmss.innerUrlPrefix");
                    final String url = parameter.getConverterUrl().contains(serverUrl) ? parameter.getConverterUrl() : (String.valueOf(serverUrl) + parameter.getConverterUrl());
                    String page = null;
                    if (parameter.getReqMap() != null) {
                        page = htmlToMht.getClientPage(parameter.getReqMap(), url);
                    }
                    else {
                        page = htmlToMht.getClientPageArchives(url);
                    }
                    page = new SysAttachmentHtmlHandler().handlingHTMLAgainZoom(page, "0.7");
                    final byte[] bytes = page.getBytes("UTF-8");
                    final String down = this.addAttachment(parameter.getModel(), parameter.getModelAttKey(), bytes, parameter.getAttFileName(), "byte", true, 0, false);
                    final String fdId = down.substring(down.indexOf("fdId=") + "fdId=".length(), down.length());
                    final SysAttMain att = (SysAttMain)this.findByPrimaryKey(fdId);
                    final ConvertParameter convertParams = new ConvertParameter(parameter.getConverterType(), parameter.getConverterKey(), "remote", new com.alibaba.fastjson.JSONObject().toString());
                    final IExtensionPoint point = Plugin.getExtensionPoint("com.landray.kmss.sys.filestore.convert.addQueue");
                    final IExtension[] extensions = point.getExtensions();
                    final IExtension extension = Plugin.getExtension(extensions, "key", "defaultAddQueue");
                    final String serviceName = Plugin.getParamValueString(extension, "service");
                    final ConvertAddQueueExtension service = (ConvertAddQueueExtension)SpringBeanUtil.getBean(serviceName);
                    final SysFileConvertQueue quene = service.addQueue(att, convertParams, (Map)null);
                    object.put("status", (Object)"success");
                    object.put("quene", (Object)quene);
                    object.put("info", (Object)"加入队列成功!");
                }
                else {
                    object.put("status", (Object)"failure");
                    object.put("info", (Object)"转换服务未开启!");
                }
            }
            catch (final Exception e) {
                e.printStackTrace();
                object.put("status", (Object)"failure");
                object.put("info", (Object)e.getMessage());
            }
        }
        return object;
    }
    
    private String genrateFileIdByPath(final String path) {
        String id = null;
        if (StringUtil.isNotNull(path)) {
            final String[] paths = path.split("/");
            if (paths.length > 4) {
                id = paths[4];
                if (id.toCharArray().length != 32) {
                    id = null;
                }
            }
        }
        if (StringUtil.isNull(id)) {
            id = IDGenerator.generateID();
        }
        if (SysAttMainCoreInnerServiceImp.logger.isDebugEnabled()) {
            SysAttMainCoreInnerServiceImp.logger.debug("传入相对路径path = {}, 生成id = {}", path, id);
        }
        return id;
    }
    
    private String copyFile(final String fdAttLocation, final String relativePath, final String prefixPath) throws Exception {
        String copyPath = null;
        InputStream inputStream = null;
        if (SysFileLocationUtil.getKey((String)null).equals(fdAttLocation)) {
            try {
                copyPath = SysFileLocationUtil.getProxyService(fdAttLocation).copy(relativePath, prefixPath);
                return copyPath;
            }
            catch (final Exception e) {
                throw new RuntimeException("调用直接文件存储服务直接copy的方式出错", e);
            }
        }
        try {
            inputStream = SysFileLocationUtil.getProxyService(fdAttLocation).readFile(relativePath, prefixPath);
            final String id = IDGenerator.generateID();
            copyPath = this.sysAttUploadService.generatePath(id);
            SysFileLocationUtil.getProxyService().writeFile(inputStream, copyPath);
        }
        catch (final Exception e) {
            throw new RuntimeException("复制文件出错了", e);
        }
        finally {
            IOUtils.closeQuietly(inputStream);
        }
        IOUtils.closeQuietly(inputStream);
        return copyPath;
    }
    
    public SysAttMain addYozowoOnlineFile(final HttpServletRequest request) throws Exception {
        if (SysAttMainCoreInnerServiceImp.logger.isDebugEnabled()) {
            SysAttMainCoreInnerServiceImp.logger.debug("复制附件处理：不存在附件流的情况。");
        }
        SysAttMain copyAtt = new SysAttMain();
        final String fdTemplateModelId = request.getParameter("fdTemplateModelId");
        final String fdTemplateModelName = request.getParameter("fdTemplateModelName");
        final String fdTemplateModelKey = request.getParameter("fdTemplateKey");
        final String fdKey = request.getParameter("fdKey");
        final String fdModelName = request.getParameter("fdModelName");
        final String fdModelId = request.getParameter("fdModelId");
        String fdFileExt = request.getParameter("fdFileExt");
        final String isPrint = request.getParameter("isPrint");
        final Object attObj = this.findFirstOne("sysAttMain.fdKey = '" + fdKey + "' and sysAttMain.fdModelId = '" + fdModelId + "' and sysAttMain.fdModelName='" + fdModelName + "'", "");
        if (attObj == null) {
            String fileExtName = "";
            InputStream in = null;
            if (StringUtil.isNotNull(fdTemplateModelId) && StringUtil.isNotNull(fdTemplateModelName) && StringUtil.isNotNull(fdTemplateModelKey)) {
                final Object obj = this.findFirstOne("sysAttMain.fdKey = '" + fdTemplateModelKey + "' and sysAttMain.fdModelId = '" + fdTemplateModelId + "' and sysAttMain.fdModelName='" + fdTemplateModelName + "'", "");
                if (obj != null) {
                    final SysAttMain tempAtt = (SysAttMain)obj;
                    in = this.getInputStream(tempAtt);
                    fileExtName = FilenameUtils.getExtension(tempAtt.getFdFileName());
                }
            }
            if (in == null) {
                String templateFilePath = "/sys/attachment/templateFile/";
                Label_0636: {
                    final String s;
                    switch (s = fdFileExt) {
                        case "doc": {
                            templateFilePath = String.valueOf(templateFilePath) + "editOnlineTemplate.doc";
                            break Label_0636;
                        }
                        case "ppt": {
                            templateFilePath = String.valueOf(templateFilePath) + "editOnlineTemplate.ppt";
                            break Label_0636;
                        }
                        case "xls": {
                            templateFilePath = String.valueOf(templateFilePath) + "editOnlineTemplate.xls";
                            break Label_0636;
                        }
                        case "docx": {
                            templateFilePath = String.valueOf(templateFilePath) + "editOnlineTemplate.docx";
                            break Label_0636;
                        }
                        case "pptx": {
                            templateFilePath = String.valueOf(templateFilePath) + "editOnlineTemplate.pptx";
                            break Label_0636;
                        }
                        case "xlsx": {
                            templateFilePath = String.valueOf(templateFilePath) + "editOnlineTemplate.xlsx";
                            break Label_0636;
                        }
                        default:
                            break;
                    }
                    fdFileExt = "docx";
                    templateFilePath = String.valueOf(templateFilePath) + "editOnlineTemplate.docx";
                }
                if ("true".equals(isPrint)) {
                    templateFilePath = "/sys/attachment/templateFile/editOnlinePrint.docx";
                }
                final File file = new File(String.valueOf(ConfigLocationsUtil.getWebContentPath()) + templateFilePath);
                if (file.exists()) {
                    in = new FileInputStream(file);
                }
                fileExtName = fdFileExt;
            }
            final ByteArrayOutputStream bao = new ByteArrayOutputStream();
            final byte[] buff = new byte[100];
            int rc = 0;
            while ((rc = in.read(buff, 0, 100)) > 0) {
                bao.write(buff, 0, rc);
            }
            final String appendStr = copyAtt.getFdId();
            final byte[] appendByte = appendStr.getBytes();
            bao.write(appendByte);
            final byte[] byt = bao.toByteArray();
            final InputStream newin = new ByteArrayInputStream(byt);
            copyAtt.setInputStream(newin);
            copyAtt.setFdModelId(fdModelId);
            copyAtt.setFdModelName(fdModelName);
            copyAtt.setFdKey(fdKey);
            final double fileSize = newin.available();
            copyAtt.setFdSize(Double.valueOf(fileSize));
            copyAtt.setFdAttType("office");
            Label_1104: {
                final String s2;
                switch (s2 = fileExtName) {
                    case "doc": {
                        copyAtt.setFdFileName("editonline.doc");
                        copyAtt.setFdContentType("application/msword");
                        break Label_1104;
                    }
                    case "ppt": {
                        copyAtt.setFdFileName("editonline.ppt");
                        copyAtt.setFdContentType("application/vnd.ms-powerpoint");
                        break Label_1104;
                    }
                    case "xls": {
                        copyAtt.setFdFileName("editonline.xls");
                        copyAtt.setFdContentType("application/vnd.ms-excel");
                        break Label_1104;
                    }
                    case "docx": {
                        copyAtt.setFdFileName("editonline.docx");
                        copyAtt.setFdContentType("application/vnd.openxmlformats-officedocument.wordprocessingml.document");
                        break Label_1104;
                    }
                    case "pptx": {
                        copyAtt.setFdFileName("editonline.pptx");
                        copyAtt.setFdContentType("application/vnd.openxmlformats-officedocument.presentationml.presentation");
                        break Label_1104;
                    }
                    case "xlsx": {
                        copyAtt.setFdFileName("editonline.xlsx");
                        copyAtt.setFdContentType("application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
                        break Label_1104;
                    }
                    default:
                        break;
                }
                copyAtt.setFdFileName("editonline.docx");
                copyAtt.setFdContentType("application/vnd.openxmlformats-officedocument.wordprocessingml.document");
            }
            if ("true".equals(isPrint)) {
                copyAtt.setFdFileName("editOnlinePrint.docx");
            }
            final ISysAttMainCoreInnerService sysAttMainService = (ISysAttMainCoreInnerService)SpringBeanUtil.getBean("sysAttMainService");
            try {
                sysAttMainService.add((IBaseModel)copyAtt);
            }
            catch (final Exception e) {
                throw new RuntimeException(e);
            }
            finally {
                if (in != null) {
                    in.close();
                }
                if (newin != null) {
                    newin.close();
                }
            }
            if (in != null) {
                in.close();
            }
            if (newin != null) {
                newin.close();
            }
        }
        else {
            copyAtt = (SysAttMain)attObj;
        }
        return copyAtt;
    }
}
